function CreateIndex(bind)
 mx=0
 ids=bind.ColData(1)
 for i=1 to UBound(ids)
  if ids(i)>mx then
   mx=ids(i)
  end if
 next
 dim ind
 redim ind(mx)
 for i=1 to UBound(ids)
  ind(ids(i)) = i
 next
 CreateIndex=ind
end function

function CheckId(id,index)
 if not IsNumeric(id) then
  CheckId=vbFalse
 else
  ii = Int(id)
  if ii<1 or ii>UBound(index) then
   CheckId=vbFalse
  else
   CheckId = (index(ii)<>"")
  end if
 end if
end function



'------------------------------------------------------------------------------
'    () 
'     
'
function SubstnFile(sid)
 'Set bind = CreateObject("Cascade.Bind")
 'Set scn  = CreateObject("Cascade.Scena") 
 bind.Open scn.MmiVar("MAINDIR") & "\" & scn.MmiVar("REGIM") & "\" & "Rel\base.rel\substn.txt$NOOIK\name\id=" & sid & "\\s"
 sm = Replace(bind(1,1)," ","_")

 file = scn.MmiVar("MAINDIR") & "\" & scn.MmiVar("REGIM") & "\Ger\subsm\" & sm & ".ger"
 if scn.ExistFile(file) Then
  SubstnFile=file
 else
  SubstnFile=""
 end if
end function

'------------------------------------------------------------------------------
'  
'
function SubstnTitle(sid)
 Set bindPs = CreateObject("Cascade.Bind")
 Set scnPs  = CreateObject("Cascade.Scena") 
 bindPs.Open scnPs.MmiVar("MAINDIR") & "\" & scnPs.MmiVar("REGIM") & "\" & "Rel\base.rel\substn.txt\name\id=" & sid & "\\s"
 SubstnTitle = bindPs(1,1)
 bindPs.Close
end function

'------------------------------------------------------------------------------
sub AddToPublicLog(s,user)
 set sc=CreateObject("Cascade.Scena")
 sc.AddToPublicLog s,user
end sub

'------------------------------------------------------------------------------
'   
'
function AmIStager()
 set cop=GetObject(,"Cop.Application")
 set pnls=cop.panels
 n=pnls.count
 for i=1 to n
  if pnls(i).caption="" then
   AmIStager=True
   exit function
  end if
 next
 AmIStager=False
end function

'------------------------------------------------------------------------------
'   
'
function AmIInstructor()
 set cop=GetObject(,"Cop.Application")
 set pnls=cop.panels
 n=pnls.count
 for i=1 to n
  if pnls(i).caption="" then
   AmIInstructor=True
   exit function
  end if
 next
 AmIInstructor=False
end function

'------------------------------------------------------------------------------
'   
'
function AmIBroker()
 set cop=GetObject(,"Cop.Application")
 set pnls=cop.panels
 n=pnls.count
 for i=1 to n
  if pnls(i).caption="" then
   AmIBroker=True
   exit function
  end if
 next
 AmIBroker=False
end function

'------------------------------------------------------------------------------
'     -
'
function AmIAnalizer()
 set cop=GetObject(,"Cop.Application")
 set pnls=cop.panels
 n=pnls.count
 for i=1 to n
  if pnls(i).caption="" then
   AmIAnalizer=True
   exit function
  end if
 next
 AmIAnalizer=False
end function

'------------------------------------------------------------------------------
'
sub SetBranchVars(regim)
Set bind1=CreateObject("Cascade.Bind")
bind1.open "rel\base.rel\branches.txt$NOOIK\struct,display=''?struct:display,BaseNode,FicTsMin,FicTsMax\regim\'"&regim&"'\c"
Set scn1 = CreateObject("Cascade.Scena")
scn1.MmiVar("REGIM")=regim
scn1.MmiVar("MAIN_COMMUT_SCHEMA")=bind1(1,1)
scn1.MmiVar("DISPLAY_SCHEMA")=bind1(2,1)
scn1.MmiVar("BASE_NODE")=bind1(3,1)
scn1.MmiVar("FIC_TS_MIN")=bind1(4,1)
scn1.MmiVar("FIC_TS_MAX")=bind1(5,1)
scn1.MmiVar("READCALCFILE")=regim&"\readcalc.sec"
end sub


'------------------------------------------------------------------------------
'     ,  
'
function ArrayToString(a)
 s=""
 for i=1 to UBound(a)
  if s<>"" then
   s = s&","
  end if
  s = s&a(i)
 next
 ArrayToString=s
end function

'------------------------------------------------------------------------------
' 
'
Function Pad0(str)
 If Len(cstr(str))=1 Then
  Pad0="0"+cstr(str)
 Else
  Pad0=cstr(str)
 End If
End Function

'-----------------------------------------------------------------------------
'   
'
sub ArrayRemoveAt(a,ii)
 for i=ii+1 to UBound(a)
  a(i-1) = a(i)
 next
 Redim Preserve a(UBound(a)-1)
end sub

'-----------------------------------------------------------------------------
Function GetSchema
	Set bind = CreateObject("Cascade.Bind")
	bind.Open("tren.sdf\options\schema\THIS\1\c")
	SchemaId = bind(1,1)
	bind.Open("Rel\base.rel\schemas.txt$NOOIK\oper\THIS\" & SchemaId & "\c")
	GetSchema = bind(1,1)
End Function

'-------------------------------------------

sub StartModelInPause(tbl)

set sc=CreateObject("Cascade.Scena")
Set paus=CreateObject("Cascade.Bind")
paus.Open scn.MmiVar("MAINDIR")&"\commod.sdf\Upravl2\AfterLoadPause\THIS\1\c"
paus(1,1)=1
paus.WriteToDB
paus.ReadFromDB
mdir=sc.MmiVar("MAINDIR")
regim=sc.MmiVar("REGIM")
sc.Go mdir&"\model.exe",""""&mdir&"\ted\"&regim&".tbl""",mdir,0,0,0
Do While CInt(paus(1,1))=1
 sc.Sleep 0.1
 paus.ReadFromDB
Loop
	
end sub

'-------------------------------------------
sub ResumeModelAfterLoad

Set paus=CreateObject("Cascade.Bind")
paus.Open "commod.sdf\Upravl2\AfterLoadPause\THIS\1\c"
paus(1,1)=0
paus.WriteToDB
	
end sub



sub SaveSet(setName)
	Set sw=CreateObject("Cascade.Switcher")

	'  
	sw.SaveTs scn.MmiVar("MAINDIR") & "\Regimes\" & setName & ".ts"

	SerializeSdfTable "tren.sdf", "Marks", setName, 1
	SerializeSdfTable "tren.sdf", "Zvk", setName, 1
	
	'SerializeSdfTable "tren.sdf", "options", setName, 1
	'SerializeSdfTable "tren.sdf", "fdr", setName, 1
	'SerializeSdfTable "tren.sdf", "gen", setName, 1
	'SerializeSdfTable "tren.sdf", "bus", setName, 1
	'SerializeSdfTable "tren.sdf", "trans1", setName, 1
	'SerializeSdfTable "tren.sdf", "frct", setName, 1
	'SerializeSdfTable "tren.sdf", "stk", setName, 1
	SaveSdfTable setName,"tren.sdf","options","THIS,CurTemp,WinterNow"
	SaveSdfTable setName,"tren.sdf","fdr","fdr_id,fdr_aload,fdr_rload"
	SaveSdfTable setName,"tren.sdf","gen","gen_id,gen_val,gen_aki,gen_qmin,gen_qmax,gen_ust_u,gen_aload,gen_rload"
	SaveSdfTable setName,"tren.sdf","bus","bus_id,bus_p,bus_q,bus_g,bus_aki,bus_qmin,bus_qmax,bus_ust_u"
	SaveSdfTable setName,"tren.sdf","frct","frct_id,frct_qmin,frct_qmax,frct_ust_u"
	SaveSdfTable setName,"tren.sdf","stk","stk_id,stk_qmin,stk_qmax,stk_ust_u,stk_q"
	
	SaveSdfTable setName,"commod.sdf", "g_tek", "NUG,BAG,DUG,UUS"
end sub

sub StartFromSet(setName)
	'    
	'
	StartModelInPause "%REGIM%"

	Set sw=CreateObject("Cascade.Switcher")

	sw.LoadTopology
	sw.FillSdf

	Set sc=CreateObject("Cascade.Scena")
	mdir=sc.MmiVar("MAINDIR")
	sw.LoadTs mdir & "\Regimes\" & setName & ".ts"
	SerializeSdfTable "tren.sdf", "Marks", setName, 0
	SerializeSdfTable "tren.sdf", "Zvk", setName, 0
	
	'SerializeSdfTable "tren.sdf", "options", setName, 0
	'SerializeSdfTable "tren.sdf", "fdr", setName, 0	
	'SerializeSdfTable "tren.sdf", "gen", setName, 0
	'SerializeSdfTable "tren.sdf", "bus", setName, 0
	'SerializeSdfTable "tren.sdf", "trans1", setName, 0
	'SerializeSdfTable "tren.sdf", "frct", setName, 0
	'SerializeSdfTable "tren.sdf", "stk", setName, 0
	
	LoadSdfTable setName,"tren.sdf","options","THIS,CurTemp,WinterNow"
	LoadSdfTable setName,"tren.sdf","fdr","fdr_id,fdr_aload,fdr_rload"
	LoadSdfTable setName,"tren.sdf","gen","gen_id,gen_val,gen_aki,gen_qmin,gen_qmax,gen_ust_u,gen_aload,gen_rload"
	LoadSdfTable setName,"tren.sdf","bus","bus_id,bus_p,bus_q,bus_g,bus_aki,bus_qmin,bus_qmax,bus_ust_u"
	LoadSdfTable setName,"tren.sdf","frct","frct_id,frct_qmin,frct_qmax,frct_ust_u"
	LoadSdfTable setName,"tren.sdf","stk","stk_id,stk_qmin,stk_qmax,stk_ust_u,stk_q"
			
	'SetSmallTextSplash "   ..."

	sw.RecalcNodes 0

	LoadSdfTable setName,"commod.sdf", "g_tek", "NUG,BAG,DUG,UUS"

	sw.RecalcLoads
	sw.RecalcShunts
	sw.RecalcGens

	' 
	ResumeModelAfterLoad
end sub

sub LoadModelCDUFile(filename)
    Set mdl = CreateObject("Cascade.Model")
    mdl.Item("SZINT\2")   = 0
    mdl.Item("CduFlag\1") = 0
    mdl.Item("CduFlag\2") = 1
    mdl.Item("CduFlag\3") = 0
    mdl.Item("CduFlag\4") = 0
    mdl.Item("CduFlag\5") = 0
    mdl.LoadCDUFile(filename)
end sub

'-----------------------------------------------------------------------------

sub ShowWaitMessage
On Error Resume Next
Set ger=GetObject(,"Sched.Application")
if not isnull(ger) then
   ger.Document.Figures("wait").Visible=1
   ger.View.Repaint
end if
end sub

sub HideWaitMessage
On Error Resume Next
Set ger=GetObject(,"Sched.Application")
if not isnull(ger) then
   ger.Document.Figures("wait").Visible=0
   ger.View.Repaint
end if
end sub

'-----------------------------------------------------------------------------
'       ( - 0,  - 1,  - 2)
sub SetDataType(ger, ByVal DataModeType)
	Set bind = CreateObject("Cascade.Bind")

	bind.Open("tren.sdf\options\ShowModel,LoadTime\THIS\1\c")
	typeData = bind(1,1)
	CurTime  = bind(2,1)
	bind.Close	

	'ger.CurTime = CurTime	
	If(DataModeType>-1) Then
		typeData = DataModeType
	End If	

	If typeData=0 Then
		'
		ger.TitleOfAdd = "libfig_OIK"
		ger.ReopenAdd
		
		Set figs = ger.Document.Figures.ExtractTechType("264")
		figs.Visible = 0

		Set figs = ger.Document.Figures.ExtractTechType("265")
		figs.Visible = 1
		
		Set figs = ger.Document.Figures.ExtractTechType("134,136,257,261,262,60,112,110,146")
		figs.KvitBlink
		
	ElseIf (typeData=1 Or typeData=3) Then
		'
		Set scn = CreateObject("Cascade.Scena")	
		Set mdl=CreateObject("Cascade.Model")
		If 	scn.ExistProcess("model.exe") And mdl.ModelState = 0 Then
			'   , 
			mdl.Start "%TBLFILE%",0
		End If
		
		
		'if(typeData=3) Then
		'	ger.TitleOfAdd = "libfig_stager"				
		'Else
		'	ger.TitleOfAdd = "libfig"		
		'End if
		'ger.ReopenAdd
		
		'    - 
		'Set db = ger.DbLinks(18,257)
		'db.Disable = 1

		'   
		'   ()
		Set db = ger.DbLinks(18,261)
		db.Disable = 1

		'   ()
		Set db = ger.DbLinks(18,262)
		db.Disable = 1

		' 
		Set db = ger.DbLinks(18,134)
		db.Disable = 1

		' 
		Set db = ger.DbLinks(18,72)
		db.Disable = 1

		'   ()
		Set db = ger.DbLinks(20,167)
		db.Disable = 1

		'   ()
		Set db = ger.DbLinks(18,65)
		db.Disable = 1
		
		Set figs = ger.Document.Figures.ExtractTechType("264")
		figs.Visible = 1

		Set figs = ger.Document.Figures.ExtractTechType("265")
		figs.Visible = 0
		
		Set figs = ger.Document.Figures.ExtractTechType("134,136,257,261,262,60,112,110,146")
		figs.KvitBlink

	ElseIf typeData=2 Then
		' 
		Set mdl=CreateObject("Cascade.Model")
		If mdl.ModelState = 0 Then
			'   , 
			mdl.Start "%TBLFILE%",0
		End If

		ger.TitleOfAdd = "libfig"
		ger.ReopenAdd

		Set db = ger.DbLinks(5,257)
		db.Disable = 0

		Set db = ger.DbLinks(18,257)
		db.Disable = 0

		Set db = ger.DbLinks(18,261)
		db.Disable = 0

		Set db = ger.DbLinks(18,262)
		db.Disable = 0

		' 
		Set db = ger.DbLinks(18,134)
		db.Disable = 0
		
		' 
		Set db = ger.DbLinks(18,72)
		db.Disable = 0	

		'   ()
		Set db = ger.DbLinks(20,167)
		db.Disable = 0		
		
		'   ()
		Set db = ger.DbLinks(18,65)
		db.Disable = 0		
		
		Set figs = ger.Document.Figures.ExtractTechType("264,265")
		figs.Visible = 1

		Set figs = ger.Document.Figures.ExtractTechType("134,136,257,261,262,60,112,110,146")
		figs.KvitBlink
		
	End If

	Set bindTop = CreateObject("Cascade.Bind")
	bindTop.Open("tren.sdf\options\Top\THIS\1\c")
	If(bindTop(1,1)=2) Then
		ger.TitleOfAdd = "libfig_corwin"
		ger.ReopenAdd
	ElseIf(bindTop(1,1)=1) Then
		ger.TitleOfAdd = "libfig_top"
		ger.ReopenAdd
	End If
	bindTop.Close

	ger.view.repaint
end sub

'        sched-
sub SetDataTypeAllWnd
	Set sc = CreateObject("Cascade.Scena")
	
	masApps = sc.AllSchedApps
	count = UBound(masApps)			
					
	For i=1 To count
		SetDataType masApps(i), -1
	Next
end sub

'------------------------------------------------------------------------------------

sub StartGer(fn, host,  DataModeType_NotUsed) 
	SetSmallTextSplash "  "&fn
	Set scn1=CreateObject("Cascade.Scena")				
	if Mid(fn,2,2)<>":\" then
		fn = scn1.MmiVar("MAINDIR") & "\" & fn
	end if
	If Not scn1.ExistFile(fn) Then
		MsgBox " "&fn&"  "
		exit sub
	end if

	If(host="" Or host="localhost") Then
		set scn1=CreateObject("Cascade.Scena")
	Else
		Set scn1 = CreateObject("Cop.Application",host).CreateObject("Cascade.Scena")
	End if

	scn1.Go "sched.exe","/run /filewnd "&""""&fn&"""",0,0,0
	QuitSplash
end sub


'------------------------------------------------------------------------------------

sub StartSubstn(caption) 
	fn=Replace(Trim(caption),vbNewLine,"_")
	if Left(UCase(fn),3)=" " and Mid(UCase(fn),8,2)="" then ' 220 
		fn=Mid(fn,11)
	elseif Left(UCase(fn),3)=" " and Mid(UCase(fn),7,2)="" then ' 220
		fn=Mid(fn,10)
	elseif Left(UCase(fn), 3)=" " then
		fn=Mid(fn,4)
	end if
	fn=Replace(fn,vbNewLine,"_")
	fn=Replace(fn," ","_")
	Set sc=CreateObject("Cascade.Scena")
	mdir=sc.MmiVar("MAINDIR")
	regim=scn.MmiVar("REGIM")
	scn.Go "sched.exe","/run /filewnd " & mdir & "\" & regim & "\Ger\Subsm\" & fn & ".ger",0,0,0
end sub


'-----------------------------------------------------------------------------
sub StartSubstn1(caption,folder) 
	fn=Replace(Trim(caption),vbNewLine,"_")
	if Left(UCase(fn),3)=" " and Mid(UCase(fn),8,2)="" then ' 220 
		fn=Mid(fn,11)
	elseif Left(UCase(fn),3)=" " and Mid(UCase(fn),7,2)="" then ' 220
		fn=Mid(fn,10)
	elseif Left(UCase(fn), 3)=" " then
		fn=Mid(fn,4)
	end if
	fn=Replace(fn,vbNewLine,"_")
	fn = folder&"\"&fn
	fn=Replace(fn," ","_")
	Set sc=CreateObject("Cascade.Scena")
	mdir=sc.MmiVar("MAINDIR")
	regim=sc.MmiVar("REGIM")
	sc.Go "sched.exe","/run /filewnd " & mdir & "\" & regim & "\Ger\Subsm\" & fn & ".ger",0,0,0
end sub

'-----------------------------------------------------------------------------
'  
Function UserName
	Set dial = CreateObject("Cascade.Dialoger")
	Set bindUserName = CreateObject("Cascade.Bind")
	
	usrName=""
	bindUserName.Open("tren.sdf\users\usr_name\usr_comp='"&dial.CurComp&"'\\s")	
	If(bindUserName.RecCount>0) Then
		usrName = bindUserName(1,1)
	End If	
	bindUserName.Close
	
	UserName = usrName	
End Function

'    Cascade
function LogIn(typeUser)
	Set bindLogIn = CreateObject("Cascade.Bind")
	Set dial = CreateObject("Cascade.Dialoger")

	name=""
	bindLogIn.Open("tren.sdf\users\usr_name\usr_comp='"&dial.CurComp&"'\\s")	
	If(bindLogIn.RecCount>0) Then
		name=bindLogIn(1,1)
	End If
	bindLogIn.Close

	If(name<>"") Then '  
		MsgBox "   ,   - "&name&"."&chr(13)&".",64,""
		LogIn = 1
	Else			  '  		
		nUser=InputBox("  ")
		If(nUser<>"") Then
			bindLogIn.Open("tren.sdf\users\usr_name,usr_comp,usr_type\\\c")
			if typeUser=0 then '   
				while bindLogIn.RecCount>0
					bindLogIn.RemoveRecord 1
				wend
			end if
			bindLogIn.AddRecord		
			rec = bindLogIn.RecCount			
			bindLogIn(1,rec)=nUser
			bindLogIn(2,rec)=dial.CurComp	
			bindLogIn(3,rec)=typeUser							
			bindLogIn.WriteToDB	
			
			LogIn = 1
			if typeUser=1 Or typeUser=3 then
				scn.MmiVar("OPERATE")="0"
			else
				scn.MmiVar("OPERATE")="1"
			end if
		Else
			LogIn = 0
		End If
	End If
end function

'    Cascade   
sub LogIn1(name)
 Set bind = CreateObject("Cascade.Bind")
 Set sc= CreateObject("Cascade.Scena")
 comp=sc.MmiVar("COMP")

 bind.Open("tren.sdf\users\usr_name\usr_comp='"&comp&"'\\s")	
 If(bindLogIn.RecCount>0) Then
  MsgBox "   ,   - "&name&"."&chr(13)&".",64,""
 Else '  		
  rec=bind.AddRecord		
  bind(1,rec)=name
  bind(2,rec)=comp		
  bind.WriteToDB	
 End If
end sub

'   
sub LogOut
	Set bindLogOut = CreateObject("Cascade.Bind")
	Set dial = CreateObject("Cascade.Dialoger")

	bindLogOut.Open("tren.sdf\users\usr_name\usr_comp='"&dial.CurComp&"'\\s")	
	If(bindLogOut.RecCount>0) Then
		bindLogOut.RemoveRecord(1)
	End If
end sub
'-----------------------------------------------------------------------------

' \   sdf 
sub SerializeSdfTable(nameBase, nameTable, nameFile, isSave)
		fullNameFile = scn.MmiVar("MAINDIR") & "\Regimes\" & nameFile & "_"+nameTable & ".sbs"
		
		Set bind_serialize = CreateObject("Cascade.Bind")
		bind_serialize.Open(nameBase+"\"&nameTable&"\\\\c")		
		
		countRec  = bind_serialize.RecCount
		countCol  = bind_serialize.ColCount	
		
		Set objFSO = CreateObject("Scripting.FileSystemObject")
		
		if(isSave) Then	'  
			Set objFile = objFSO.CreateTextFile(fullNameFile, True)				
				For i=1 To countRec
					For j=1 To countCol
						If(i=countRec And j=countCol) Then
							objFile.Write Replace(bind_serialize(j,i),",",".")	
						Else
							objFile.WriteLine Replace(bind_serialize(j,i),",",".")								
						End If			
					Next
				Next
			objFile.Close
		Else '     sdf

			'  				
			For i=1 To countRec
				bind_serialize.RemoveRecord(1)
			Next
			Set objFile = objFSO.OpenTextFile(fullNameFile, 1, True) 		
				If(Not objFile.AtEndOfStream) Then			
				
					allStr = objFile.ReadAll
					
					masStr = Split(allStr,chr(13))
					countStr = UBound(masStr)
					i=1
					j=1				
					For k=0 To countStr
						If(k=0) Then
							valStr = masStr(k)
							bind_serialize.AddRecord
						Else
							valStr = Replace(Right(masStr(k),Len(masStr(k))-1),",",".")
						End If
						
						bind_serialize(j,i)=valStr
						
						If((j+1)>countCol) Then
							i=i+1
							j=1						
							If(i<=CInt((countStr+1)/countCol)) Then
								bind_serialize.AddRecord
							End If
						Else
							j=j+1
						End If
					Next				
				End If
			objFile.Close			
			bind_serialize.WriteToDB

		End If
		
		bind_serialize.Close
end sub

' \    sdf 
sub SerializeSdfTableField(nameBase, nameTable, nameFields, idName, Condition, nameFile, isSave)
	fullNameFile = nameFile+".sbs"
		
	Set bind_serialize = CreateObject("Cascade.Bind")
	bind_serialize.Open(nameBase+"\"&nameTable&"\"&idName&","&nameFields&"\"&Condition&"\"&idName&"\s")		
		
	masFields = Split(nameFields,",")
		
	countRec  = bind_serialize.RecCount
	countCol  = UBound(masFields)
		
	'MsgBox 	countRec&", "&Condition
		
	Set objFSO = CreateObject("Scripting.FileSystemObject")
		
	if(isSave) Then	'  
		Set objFile = objFSO.CreateTextFile(fullNameFile, True)				
			For i=1 To countRec
				For j=1 To countCol+2						'
					If(i=countRec And j=countCol+2) Then			
						objFile.Write bind_serialize(j,i)	
					Else
						objFile.WriteLine bind_serialize(j,i)											
					End If			
				Next			
			Next
			objFile.Close
	Else '     sdf
		flag=0
		Set objFile = objFSO.OpenTextFile(fullNameFile, 1, True) 		
		If(Not objFile.AtEndOfStream) Then							
			allStr = objFile.ReadAll
				
			masStr = Split(allStr,chr(13))
			countStr = UBound(masStr)
				
			Set prog=CreateObject("Cascade.Progress")					
			prog.show
			prog.text = "    - "&nameBase
			prog.low=0
			prog.up=countStr


			'bind_serialize.Open(nameBase+"\"&nameTable&"\"&nameFields&"\"&idName&"=CStr(Trim("&valStr&"))\"&idName&"\s")					
			k=0
			Do Until k>countStr
				If(k=0) Then
					valStr = masStr(k)
				Else
					valStr = Right(masStr(k),Len(masStr(k))-1)
				End If
				k=k+1						
				prog.pos=k
				
				index = FastSearch(bind_serialize,valStr)
				If (index<>-1) Then
					For j=2 To countCol+2
						valStr = Right(masStr(k),Len(masStr(k))-1)			
						k=k+1	
						prog.pos=k
						bind_serialize(j,index)=valStr

					Next
				Else
					If(flag=0) Then
						MsgBox "  !!!"		
						flag=1
					End If
				End If
			Loop			
				
			bind_serialize.WriteToDB
			prog.Hide
		End If
		objFile.Close			
	End If
	bind_serialize.Close					
end sub
'-----------------------------------------------------------------------------
sub SaveSdfTable(setName,baseName,tabName,fields)
	Set b = CreateObject("Cascade.Bind")
	Set fso = CreateObject("Scripting.FileSystemObject")
	Set sc = CreateObject("Cascade.Scena")
	mdir=sc.MmiVar("MAINDIR")
	fileName = mdir & "\Regimes\" & setName & "_" & tabName & ".sbs"
	Set file = fso.CreateTextFile(fileName, True)
	b.Open mdir & "\" & baseName & "\" & tabName & "\" & fields & "\\\c"
	s=""
	for c=1 to b.ColCount
		if c>1 then
			s = s & "	"
		end if
		s = s & b.ColRef(c)
	next
	file.WriteLine s
	for r=1 to b.RecCount
		s=""
		for c=1 to b.ColCount
			if c>1 then
				s = s & "	"
			end if
			s = s & b(c,r)
		next
		file.WriteLine s
	next
end sub

sub LoadSdfTable(setName,baseName,tabName,fields)
	Set b = CreateObject("Cascade.Bind")
	Set fso = CreateObject("Scripting.FileSystemObject")
	Set sc = CreateObject("Cascade.Scena")
	mdir=sc.MmiVar("MAINDIR")
	fileName = mdir & "\Regimes\" & setName & "_" & tabName & ".sbs"
	Set file = fso.OpenTextFile(fileName, 1, True)
	b.Open mdir & "\" & baseName & "\" & tabName & "\" & fields & "\\\c"
	index=CreateIndex(b)
	while not file.AtEndOfStream
		s=file.ReadLine
		sa=Split(s,"	")
		if CheckId(sa(0),index) then
			rec=index(Int(sa(0)))
			for c=1 to b.ColCount-1
				b(c+1,rec) = sa(c)
			next
		end if
	wend
	b.WriteToDB
end sub
'-----------------------------------------------------------------------------
Function FastSearch(FS_bind_serialize,FS_valStr)
	result=-1
	p=1
	q=FS_bind_serialize.RecCount
	b=CLng(FS_valStr)
	
	Do Until p>=q
		s=(p+q)\2
		If CLng(FS_bind_serialize(1,s))<b Then
			p=s+1
		Else
			q=s
		End If	
	Loop	
	If(CLng(FS_bind_serialize(1,p))=b) Then
		result=p
	End If
	
	FastSearch=result
End Function
'-----------------------------------------------------------------------------
'  Splash 

sub CreateSplash(bigText,smallText)
	Set appCop = CreateObject("Cop.Application")
	
    Set appSplash = appCop.OpenPanel(""""&scn.MmiVar("MAINDIR")&"\pnl\splash.pnl""")

    appSplash.Objects(1).Caption = bigText
    appSplash.Objects(3).Caption = smallText

    appSplash.Repaint
end sub

sub SetSmallTextSplash(smallText)
    Set copApp = CreateObject("Cop.Application")
	For i=1 To copApp.Panels.Count
		If(copApp.Panels(i).Caption="splash") Then
			copApp.Panels(i).Objects(3).Caption = smallText
			copApp.Panels(i).Repaint			
			i=copApp.Panels.Count
		End If
	Next
end sub

sub SetBigTextSplash(bigText)
    Set copApp = CreateObject("Cop.Application")
	For i=1 To copApp.Panels.Count
		If(copApp.Panels(i).Caption="splash") Then
			copApp.Panels(i).Objects(1).Caption = bigText
			copApp.Panels(i).Repaint			
			i=copApp.Panels.Count
		End If
	Next
end sub

sub QuitSplash
    Set copApp = CreateObject("Cop.Application")
	For i=1 To copApp.Panels.Count
		If(copApp.Panels(i).Caption="splash") Then
			copApp.Panels(i).Quit
		Exit For
		End If
	Next
end sub
'-----------------------------------------------------------------------------

sub SetLViewVars(id,host)
 if host="localhost" then
  Set scn1=CreateObject("Cascade.Scena")
 else
  set ger=CreateObject("Sched.Application",host)
  set scn1=ger.CreateObject("Cascade.Scena")
 end if
 Set bind1=CreateObject("Cascade.Bind")
 bind1.Open "rel\base.rel\LineShow.txt$NOOIK\\id\"&id&"\c"
 For i=4 To bind.ColCount
  scn1.MmiVar(bind1.ColRef(i)) = bind1(i,1)
 Next
end sub

function TUvalidSub(subid)
	bind.Open "tren.sdf\substn\sub_tu=1\sub_id\"&subid&"\c"
	TUvalidSub=CBool(bind(1,1))
end function

function TUvalid(tsNum)
	bind.Open "commod.sdf\op_ts\op_ts_SubId,op_ts_type\op_ts_id\"&tsNum&"\c"
	'if bind(2,1)<>1 and bind(2,1)<>4 then '      
	'	TUvalid=false
	'	exit function
	'end if
	subid=bind(1,1)
	bind.Open "tren.sdf\substn\sub_tu=1\sub_id\"&subid&"\c"
	TUvalid=CBool(bind(1,1))
end function

function AlarmTs(tsNum)
	set b=CreateObject("Cascade.Bind")
	b.Open "commod.sdf\op_ts\op_ts_alarm\op_ts_id\"&tsNum&"\c"
	AlarmTs=CBool(b(1,1))
end function

'-----------------------------------------
'  
sub SetTs(tsNum,newState)
	if AlarmTs(tsNum) then
		MsgBox "  .  !"
		exit sub
	end if
	If AmIStager Then ' -     
		if not TUvalid(tsNum) then
			MsgBox "   !"
			exit sub
		end if
		bind.Open "commod.sdf\op_ts\op_ts_name\op_ts_id\"&tsNum&"\c"
		name=bind(1,1)
		if newState then
			action=""
		else
			action=""
		end if
		if MsgBox(action&"  : "&name&" ?",vbYesNoCancel)<>vbYes then
			exit sub
		end if
		Set nmsg = CreateObject("Cascade.NetMsg")
		nmsg.SetTs tsNum,newState
	ElseIf AmIInstructor Or AmIAnalizer then ' 
		Set sw = CreateObject("Cascade.Switcher")
		sw.SetTs tsNum, newState
	Else '  
		Set nmsg = CreateObject("Cascade.NetMsg")
		nmsg.SetTs tsNum,newState
	End If
end sub

'-----------------------------------------
' 
sub SwitchTs(tsNum)
	if AlarmTs(tsNum) then
		MsgBox "  .  !"
		exit sub
	end if
	If AmIStager Then ' -     
		if not TUvalid(tsNum) then
			MsgBox "   !"
			exit sub
		end if
		bind.Open "commod.sdf\op_ts\op_ts_name\op_ts_id\"&tsNum&"\c"
		name=bind(1,1)
		if MsgBox("   : "&name&" ?",vbYesNoCancel)<>vbYes then
			exit sub
		end if
		Set nmsg = CreateObject("Cascade.NetMsg")
		nmsg.SwitchTs tsNum
	ElseIf AmIInstructor Or AmIAnalizer then ' 
		Set sw = CreateObject("Cascade.Switcher")
		sw.SwitchTs tsNum
	Else '  
		Set nmsg = CreateObject("Cascade.NetMsg")
		nmsg.SwitchTs tsNum
	End If
end sub

Function BreakerName(brkId)
	set b=CreateObject("Cascade.Bind")
	b.Open "commod.sdf\op_ts\op_ts_name\op_ts_id\" & brkId & "\\c"
	BreakerName=b(1,1)
end function

Function SubDispName(subId)
	set b=CreateObject("Cascade.Bind")
	b.Open "tren.sdf\substn\sub_dispname\sub_id\" & subId & "\c"
	SubDispName=b(1,1)
end function

'-----------------------------------------
'   
sub SetGvoBreakers(subId,sequen,who,newState)
	bind.Open "tren.sdf\gvo\gvo_BrkId,gvo_LoadDesc\gvo_SubId="&subId&" & gvo_Sequen="&sequen&" & gvo_Who='"&who&"'\gvo_LoadDesc\s"

	If AmIStager Then 
		'     
		'if not TUvalidSub(subId) then 
		'	MsgBox "   !"
		'	exit sub
		'end if
		
		if newState then
			action=""
		else
			action=""
		end if
		
		'  
		if MsgBox(action&"   "&sequen&"    ["&SubDispName(subId)&"]: "&ArrayToString(bind.ColData(2))&" ?",vbYesNoCancel)<>vbYes then
			exit sub
		end if
	End If
	
		
	if not newState then
		newState=2 '       :(
	end if
		
	If AmIInstructor Or AmIAnalizer then ' 
		Set sw=CreateObject("Cascade.Switcher")
		sw.ModelPause
		for i=1 to bind.RecCount
			sw.SetTs bind(1,i), newState
		next
		sw.ModelResume
	Else '  
		Set nmsg = CreateObject("Cascade.NetMsg")
		nmsg.ModelPause
		for i=1 to bind.RecCount
			nmsg.SetTs bind(1,i), newState
		next
		nmsg.ModelResume
	End If
end sub


'-----------------------------------------
'     
function TopoTypes(stypes)
	set scn1=CreateObject("Cascade.Scena")
	typeArray=Split(stypes,",")
	types=""
	for i=0 to UBound(typeArray)
		s=scn1.IniVar("topology.ini","Types",typeArray(i))
		types = types & "," & s
	next
	types = Mid(types,2)
	TopoTypes=types
end function

function ChooseSet
    Set listBox = CreateObject("Cascade.ListBox")
    listBox.Caption = " "
    listBox.Multi=False
    files = scn.FileList(scn.MmiVar("MAINDIR")&"\Regimes","*.ts",False,False)
    For i=1 To UBound(files)
            listBox.AddString files(i)
    Next
    If (listBox.DoDialog And listBox.SelString<>"") Then
        ChooseSet = listBox.SelString
    Else
        ChooseSet=""
    End If
end function

function IsFigTopoType(fig,sTopoTypes)
	techTypes=TopoTypes(sTopoTypes)
	sa=Split(techTypes,",")
	IsFigTopoType=false
	for i=0 to UBound(sa)
		if Int(sa(i))=Int(fig.TechType) then
			IsFigTopoType=true
		end if
	next
end function

function IsFigBreaker(fig)
	IsFigBreaker = IsFigTopoType(fig,"AutoBreaker,HandBreaker,MobileBreaker")
end function

'------
'      
'Sub WriteArgToCommandSCN(args)
'	mainDirStr = CStr(scn.MmiVar("MAINDIR"))
'	set b = CreateObject("Cascade.Bind")
'	b.Open(mainDirStr & "\cascade.sdf\ScnRec\on,name\THIS\1\c")
'	isScnOn = b(1,1)
'	nameScn = b(2,1)
'	b.Close()
'	
'	'MsgBox isScnOn
'	Set fso = CreateObject("Scripting.FileSystemObject")
'	If(isScnOn = 1) Then
'		If fso.FileExists(mainDirStr & "\Scn\" & nameScn & ".scn") Then
'			Set f = fso.OpenTextFile(mainDirStr & "\Scn\" & nameScn & ".scn", 8)
'			f.Write(","&args)
'			'MsgBox(args)
'			f.Close()
'		End If
'	End If
'End Sub

'-----------------------------------------
'     
Sub WriteCommandToSCN(commandStr,boxStr,commentStr)	
	set b=CreateObject("Cascade.Bind")
	mainDirStr = CStr(scn.MmiVar("MAINDIR"))
	b.Open mainDirStr & "\cascade.sdf\ScnRec\on,name,times,boxes,comments,lastRecordTime\THIS\1\c"
	isScnOn   = CLng(b(1,1))
	nameScn   = CStr(b(2,1))
	isTimes   = CLng(b(3,1))
	isBoxes   = CLng(b(4,1))
	isComment = CLng(b(5,1))
	lastTime  = CLng(b(6,1))
	
	Set fso = CreateObject("Scripting.FileSystemObject")	
	If(CLng(isScnOn)=CLng(1)) Then
		If fso.FileExists(mainDirStr & "\Scn\" & nameScn & ".scn") Then
			ind=CLng(0)			
			On Error Resume Next
			Do
				Set objLog = fso.OpenTextFile(mainDirStr & "\Scn\" & nameScn & ".scn", 8,1)				
				If(Err.Number <> 0) Then					
					scn.Sleep 1
					ind=CLng(ind)+CLng(1)					
				End If			
			Loop Until (Err.Number=0 Or CLng(ind)>30)
			On Error Goto 0			
			
			If(CLng(ind)<30 And Err.Number=0) Then
				'objLog.WriteLine "__ %1%," & FormatNumber(rezTRK,5,True,False,False) & "," & rezultValue			
				objLog.WriteLine
				objLog.WriteLine			
				If(CLng(isTimes)=CLng(1)) Then
					objLog.WriteLine "SLEEP " & FormatNumber(CDbl(scn.TickCount-lastTime)/1000.0,1,True,False,False)				
					objLog.WriteLine
				End If
			
				If(CLng(isComment)=CLng(1)) Then
					objLog.WriteLine "//" & commentStr
				End If
				
				If(CLng(isBoxes)=CLng(1)) Then
					objLog.WriteLine "BOX " & boxStr
				End If
				
				objLog.WriteLine commandStr
				objLog.Close
				bind(6,1) = scn.TickCount
				bind.WriteToDB
			End If
		End If
	End If
	b.Close	
End Sub
'-----------------------------------------

sub RecalcFrct(frctId)
	set bindTren=CreateObject("Cascade.Bind")
	set bindCommod=CreateObject("Cascade.Bind")
	bindTren.Open "tren.sdf\frct\frct_ust_u,frct_qmin,frct_qmax\frct_id\"&frctId&"\c"
	MsgBox bindTren.RecCount
	bindCommod.Open "commod.sdf\g_tek\UUS,QMIN,QMAX,UGN\NUG\"&frctId&"\c"
	MsgBox bindCommod.RecCount
	bindCommod(1,1) = bindTren(1,1)*500/bindCommod(4,1)
	bindCommod(2,1) = bindTren(2,1)
	bindCommod(3,1) = bindTren(3,1)
	bindCommod.WriteToDB
end sub


'-----------------------------------------
'
sub RecalcGens
 If AmIStager Or AmIBroker Then
  Set nmsg = CreateObject("Cascade.NetMsg")
  nmsg.RecalcGens
 Else
  Set sw = CreateObject("Cascade.Switcher")
  sw.RecalcGens
 End If
end sub

'-----------------------------------------
'
sub ModelRecalculate
 If AmIStager Or AmIBroker Then
	Set nmsg = CreateObject("Cascade.NetMsg")
	nmsg.ModelRecalculate
 Else
	Set mdl=CreateObject("Cascade.Model")
	mdl.Recalculate
 End If
end sub

'-----------------------------------------
'
sub ModelPause
 If AmIStager Or AmIBroker Then
	Set nmsg = CreateObject("Cascade.NetMsg")
	nmsg.ModelPause
 Else
	Set mdl=CreateObject("Cascade.Model")
	mdl.Pause
 End If
end sub

'-----------------------------------------
'
sub ModelResume
 If AmIStager Or AmIBroker Then
	Set nmsg = CreateObject("Cascade.NetMsg")
	nmsg.ModelResume
 Else
	Set mdl=CreateObject("Cascade.Model")
	mdl.Resume
 End If
end sub

'-----------------------------------------
'
sub ModelWaitExecuting(newState)
 If AmIStager Or AmIBroker Then
	Set nmsg = CreateObject("Cascade.NetMsg")
	nmsg.ModelWaitExecuting(newState)
 Else
	Set mdl=CreateObject("Cascade.Model")
	mdl.WaitExecuting=newState
 End If
end sub

function GetNewMarkX(devId,devType)
	bind.open "tren.sdf\Marks\MrkX,MrkY\MrkTypeEq="&devType&"&MrkCodeEq="&devId&"\\s"
	x=0
	norm=false
	do while not norm
		norm=true
		for i=1 to bind.RecCount
			x1=bind(1,i)
			y1=bind(2,i)
			r=Sqr((x1-x)^2+y1^2)
			'MsgBox r
			if r<20 then
				norm=false
			end if
		next
		if not norm then
			x=x+20
		end if
	loop
	GetNewMarkX=x
end function

sub AddMark(devId,devType,markType,markComment)
	'MsgBox devId & " " & devType,vbSystemModal

	Set spr=CreateObject("Cascade.Bind")
	spr.open "rel\base.rel\SprMarks.txt\DispatchMarkName,DispatchMarkShortName,Icon\NUM(CodDispatchMark)\"&markType&"\c"

	Set maxid=CreateObject("Cascade.Bind")
	maxid.Open "{MAX(a);a=tren.sdf\Marks\MrkId\\\c}"

	'  
	'
	'regim=scn.MmiVar("REGIM")
	'fn="Ted\"&regim&".tbl"
	Set nam=CreateObject("Cascade.Bind")
	subid=0
	If devType=1 Then
	 'nam.open fn&"\l\NAL\Lnum\"&devId&"\c"
	 nam.open "tren.sdf\line\line_name\line_id\"&devId&"\c"
	ElseIf devType=2 Then
	 'nam.open fn&"\op_ts\op_ts_name\op_ts_id\"&devId&"\c"
	 nam.open "tren.sdf\abr\abr_name,abr_SubId\abr_ts\"&devId&"\c"
	ElseIf devType=3 Then
	 nam.open "tren.sdf\bus\bus_name,bus_subid\bus_id\"&devId&"\c"
	End If
	devName=nam(1,1)
	subId=nam(2,1)
	if devType<>1 then
		nam.open "tren.sdf\substn\sub_dispname\sub_id\"&subId&"\c"
		subName = nam(1,1)
		devName = "["&subName&"]..["&devName&"]"
	end if
	
	'  .     
	mrkX=GetNewMarkX(devId,devType)

	bind.open "tren.sdf\Marks\MrkId,MrkType,MrkName,MrkSymbol,MrkIcon,MrkTime,MrkAuthor,MrkComment,MrkCodeEq,MrkTypeEq,MrkEqName,MrkX\\\c"
	rec=bind.AddRecord
	bind("MrkId",rec)=maxid(1,1)+1 '    
	bind("MrkType",rec)=markType '   
	bind("MrkCodeEq",rec)=devId
	bind("MrkTypeEq",rec)=devType
	bind("MrkEqName",rec)=devName
	bind("MrkName",rec)=spr("DispatchMarkName",1) '   :     ..
	bind("MrkSymbol",rec)=spr("DispatchMarkShortName",1) '  : ,   ..
	bind("MrkIcon",rec)=spr("Icon",1) '    glf
	bind("MrkTime",rec)=scn.MmiVar("TIMET")
	bind("MrkAuthor",rec)=UserName
	bind("MrkComment",rec)=markComment
	bind("MrkX",rec)=mrkX
	bind.WriteToDB
	
	scn.AddToPublicLog "  " &spr(1,1)&"  "&nam(1,1),UserName
end sub

sub FillCheckList(chList,connect,widths)
	bind.Open connect
	chList.Ctrl.ClearColumns
	If chList.Ctrl.ColumnCount = 0 Then 
		for i=1 to bind.ColCount
			chList.Ctrl.AddColumn bind.ColCaption(i), 0, widths(i), True
		next
	End If

	chList.Ctrl.ClearItems

	count = bind.RecCount
	For i=1 To count
		n = chList.Ctrl.AddItem ("","")
		for j=1 to bind.ColCount
			chList.Ctrl.SetItem   n, j, bind(j,i)
			chList.Ctrl.Checked(n) = 1
		next
	Next
	chList.Ctrl.Refresh
end sub

function DeviceName(devId,devType,subId,subDispName)
	subId=0
	subDispName=""
	Set nam=CreateObject("Cascade.Bind")
	If devType=1 Then
		nam.open "tren.sdf\line\line_name\line_id\"&devId&"\c"
	ElseIf devType=2 Then
		nam.open "tren.sdf\abr\abr_name,abr_SubId\abr_ts\"&devId&"\c"
	ElseIf devType=3 Then
		nam.open "tren.sdf\bus\bus_name,bus_subid\bus_id\"&devId&"\c"
	ElseIf devType=4 Then
		nam.open "tren.sdf\trans2\trans2_name,trans2_SubId\trans2_id\"&devId&"\c"
	ElseIf devType=5 Then
		nam.open "tren.sdf\trans3\trans3_name,trans3_SubId\trans3_id\"&devId&"\c"
	End If
	DeviceName=nam(1,1)
	if nam.ColCount>1 then
		subId=nam(2,1)
		nam.open "tren.sdf\substn\sub_dispname\sub_id\"&subId&"\c"
		subDispName = nam(1,1)
	end if
end function

function AddZvk(devId,devType)
	'MsgBox devId & " " & devType,vbSystemModal

	Set maxid=CreateObject("Cascade.Bind")
	maxid.Open "{MAX(a);a=tren.sdf\Zvk\zvk_Id\\\c}"

	devName=DeviceName(devId,devType,subId,subName)

	bind.open "tren.sdf\Zvk\zvk_Id,zvk_DevId,zvk_DevType,zvk_DevName,zvk_SubId,zvk_SubDispName,zvk_BegTime,zvk_EndTime,zvk_Avar,zvk_State\\\c"
	rec=bind.AddRecord
	AddZvk=maxid(1,1)+1
	bind("zvk_Id",rec)=maxid(1,1)+1 '    
	bind("zvk_DevId",rec)=devId
	bind("zvk_DevType",rec)=devType
	bind("zvk_DevName",rec)=devName
	bind("zvk_SubId",rec)=subId
	bind("zvk_SubDispName",rec)=subName
	bind("zvk_BegTime",rec)=0
	bind("zvk_EndTime",rec)=0
	bind("zvk_Avar",rec)=0
	bind("zvk_State",rec)=0
	bind.WriteToDB
	
	
	devName = "["&devName&"]"
	if devType<>1 then
		devName = "["&subName&"].."&devName
	end if
	scn.AddToPublicLog "   "&devName,UserName
	
end function

sub GetRetro(fields,rid)
 If AmIAnalizer Or AmIInstructor Then
	Set mu=CreateObject("Cascade.ModelUtil")
	mu.GetRetro fields,rid
 Else
	Set nmsg = CreateObject("Cascade.NetMsg")
	nmsg.GetRetro fields,rid
 End If
end sub

sub AddToPublicLog(str,user)
 If AmIAnalizer Or AmIInstructor Then
	Set scn1=CreateObject("Cascade.Scena")
	scn1.AddToPublicLog str,user
 Else
	Set nmsg = CreateObject("Cascade.NetMsg")
	nmsg.AddToPublicLog str,user
 End If
end sub

function VoltByColor(figColor)
	set scn1=CreateObject("Cascade.Scena")
	if CLng(figColor)=CLng(scn1.CascadeColor(18)) then
		VoltByColor = 220
	elseif CLng(figColor)=CLng(scn1.CascadeColor(133)) then
		VoltByColor = 35
	elseif CLng(figColor)=CLng(scn1.CascadeColor(135)) then
		VoltByColor = 10
	elseif CLng(figColor)=CLng(scn1.CascadeColor(136)) then
		VoltByColor = 6
	elseif CLng(figColor)=CLng(scn1.CascadeColor(137)) then
		VoltByColor = 0.4
	else
		VoltByColor = 0
	end if
end function

sub UpdateAllScheds
	gers = scn.AllSchedApps
	For i = 1 To UBound(gers)
		gers(i).view.Repaint
	Next
end sub