/*****************************************************************/
/* h-   Tabula     */
/*  : c:\casfsk\commod.sdf                                */
/*****************************************************************/

#ifndef __commod_h_19_07_2024
#define __commod_h_19_07_2024

#pragma pack(push, 1)

#ifdef __cplusplus
extern "C" {
#endif
#ifndef __TABULA_STRUCT__29_09_2006
#define __TABULA_STRUCT__29_09_2006

#include <windows.h>
#include <stdlib.h>
#include <malloc.h>
#include <string.h>

// -     sdf 

//  
struct sField{
	char	name[256];			// 
	WORD	type;				// 
	DWORD	off;				//      
	DWORD	offData;			// --//--  
};

//  
struct sTable{
	char	name[256];			// 
	DWORD	off;				//     -   
	DWORD	offData;			// --//-- -  	
	DWORD	nCountR;			//-  ()
	WORD	nCountF;			//- 
	DWORD	SizeOfFields;		//  
	DWORD	*p_CurRecord;		//  
	
	struct sField* infoField;	//   	
};

// -   
#define TYPESIZE(t) (t + (t == 3) + 3 * (t == 5) - 2 * (t == 6) - 8 * (t >= 8))

#endif //__TABULA_STRUCT__29_09_2006

//   
typedef char c12[12];
typedef char c30[30];
typedef char c50[50];
typedef char c100[100];
typedef char c128[128];
typedef char c255[255];
typedef char c2048[2048];

// :  
extern DWORD rpn_type_max; //    
extern DWORD *p_rpn_type; //     
#define	rpn_type_cur	(*p_rpn_type) //   
extern int    *rpn_id; // : 
extern c100   *rpn_name; // : 
extern float  *rpn_Snom; // : S ()
extern float  *rpn_UmaxNom; // :  
extern float  *rpn_UminNom; // :  
extern float  *rpn_H; // :   (%)
extern short  *rpn_Nanc; // :  
extern BYTE   *rpn_NneutralAnc; // :   
extern float  *rpn_DDopVn; // : I , 
extern float  *rpn_DDopSn; // : I C, 
extern float  *rpn_DDopNn; // : I , 
extern short  *rpn_arnt_p; // :  

// : cxn
extern DWORD cxn_max; //    
extern DWORD *p_cxn; //     
#define	cxn_cur	(*p_cxn) //   
extern float  *A0; // : 
extern float  *A1; // : 
extern float  *A2; // : 
extern float  *AF; // : 
extern float  *B0; // : 
extern float  *B1; // : 
extern float  *B2; // : 
extern float  *BF; // : 

// :  
extern DWORD Param_Lim_Q_max; //    
extern DWORD *p_Param_Lim_Q; //     
#define	Param_Lim_Q_cur	(*p_Param_Lim_Q) //   
extern int    *IdLim; // : Id
extern c100   *NameParamG; // : 
extern float  *cosF; // : cos_
extern float  *Qnom; // :    
extern float  *Xd; // :  
extern float  *kI; // :      
extern float  *kE; // :      
extern float  *kP1; // : P1/Pnom
extern float  *Q1; // : Q1, 
extern float  *kP2; // : P2/Pnom
extern float  *Q2; // : Q2, 
extern float  *kP3; // : P3/Pnom
extern float  *Q3; // : Q3, 

// : 
extern DWORD sections_max; //    
extern DWORD *p_sections; //     
#define	sections_cur	(*p_sections) //   
extern short  *sec_Id; // :  
extern c100   *sec_name; // : 
extern c50    *sec_ForDirName; // :   
extern c50    *sec_RevDirName; // :   
extern float  *sec_flow; // :  
extern float  *sec_ForLim; // :  
extern float  *sec_RevLim; // :  
extern float  *sec_flowR; // :  
extern float  *sec_lossA; // :  
extern float  *sec_lossR; // :  
extern float  *sec_nflow; // :   

// : sections_mem
extern DWORD sections_mem_max; //    
extern DWORD *p_sections_mem; //     
#define	sections_mem_cur	(*p_sections_mem) //   
extern short  *secmem_IdSec; // :  _
extern int    *secmem_IdLine; // :  _    L_tek
extern int    *secmem_IdNode1; // :  _  1_    All_nodes_
extern int    *secmem_IdNode2; // :  _  2_    All_nodes_
extern float  *secmem_DiffPh; // :     1- 2

// : fcmp
extern DWORD fcmp_max; //    
extern DWORD *p_fcmp; //     
#define	fcmp_cur	(*p_fcmp) //   
extern int    *fcmp_k1; // : fcmp_k1
extern int    *fcmp_k2; // : fcmp_k2

// : Reg
extern DWORD Reg_max; //    
extern DWORD *p_Reg; //     
#define	Reg_cur	(*p_Reg) //   
extern short  *TechNumReg; // :   
extern c50    *NameRegions; // :  
extern float  *RegGenAct; // : 
extern float  *RegGenRea; // : 
extern float  *RegLoadAct; // : 
extern float  *RegLoadRea; // : 
extern float  *RegSalAct; // : 
extern float  *RegSalRea; // : 
extern float  *USP; // :  
extern float  *VALS; // :  
extern float  *KFR; // :   
extern float  *FPRS; // : _ _
extern float  *FINS; // : _ _
extern float  *PRMAX; // : _ _
extern float  *PRMIN; // : _ _
extern char   *QREG_MAX; // :  _ _ _
extern char   *QREG_MIN; // :  _ _ _
extern float  *PRSUM; // :  
extern float  *UCP; // :  
extern float  *FCP; // :  
extern float  *UIN; // :  

// : ts
extern DWORD op_ts_max; //    
extern DWORD *p_op_ts; //     
#define	op_ts_cur	(*p_op_ts) //   
extern int    *op_ts_id; // :  -
extern c50    *op_ts_name; // :  -
extern c30    *op_ts_SubDispName; // : 
extern BYTE   *op_ts_type; // :  
extern BYTE   *op_ts_state; // :  
extern BYTE   *op_ts_norm; // :  
extern BYTE   *op_ts_past; // :  
extern BYTE   *op_ts_kvit; // :  
extern BYTE   *op_ts_alarm; // :  
extern int    *op_ts_beg; // : op_ts_beg
extern int    *op_ts_end; // : op_ts_end
extern BYTE   *corrected; // : corrected
extern float  *op_ts_u1; // :   1-  
extern float  *op_ts_u2; // :   2-  
extern short  *op_ts_SubId; // :  ()
extern int    *op_ts_SubInd; // :   ()

// :   
extern DWORD rpnTab_type_max; //    
extern DWORD *p_rpnTab_type; //     
#define	rpnTab_type_cur	(*p_rpnTab_type) //   
extern int    *rpnTab_id; // :   
extern float  *ANC1; // : 1
extern float  *ANC2; // : 2
extern float  *ANC3; // : 3
extern float  *ANC4; // : 4
extern float  *ANC5; // : 5
extern float  *ANC6; // : 6
extern float  *ANC7; // : 7
extern float  *ANC8; // : 8
extern float  *ANC9; // : 9
extern float  *ANC10; // : 10
extern float  *ANC11; // : 11
extern float  *ANC12; // : 12
extern float  *ANC13; // : 13
extern float  *ANC14; // : 14
extern float  *ANC15; // : 15
extern float  *ANC16; // : 16
extern float  *ANC17; // : 17
extern float  *ANC18; // : 18
extern float  *ANC19; // : 19
extern float  *ANC20; // : 20

// : 3-  
extern DWORD trans_max; //    
extern DWORD *p_trans; //     
#define	trans_cur	(*p_trans) //   
extern int    *trans_id; // :    g/n
extern short  *trans_SubId; // : trans_SubId
extern int    *trans_line1; // :   ( 1)   
extern int    *trans_line2; // :   ( 1)   
extern int    *trans_line3; // :   ( 1)   
extern float  *trans_per1; // :     
extern float  *trans_per2; // :     
extern float  *trans_per3; // :     
extern float  *trans_peq1; // :     
extern float  *trans_peq2; // :     
extern float  *trans_peq3; // :     
extern float  *trans_tok1; // :    
extern float  *trans_tok2; // :    
extern float  *trans_tok3; // :    

// :  
extern DWORD CDU_max; //    
extern DWORD *p_CDU; //     
#define	CDU_cur	(*p_CDU) //   
extern BYTE   *sign_CDU; // :  
extern c255   *FileName_CDU; // :   
extern float  *fTime_CDU; // : 
extern short  *LoadOnce; // : LoadOnce

// : blocks
extern DWORD blocks_max; //    
extern DWORD *p_blocks; //     
#define	blocks_cur	(*p_blocks) //   
extern int    *blocks_nug; // : blocks_nug
extern BYTE   *blocks_num; // : blocks_num
extern short  *blocks_ts1; // : blocks_ts1
extern short  *blocks_ts2; // : blocks_ts2
extern short  *blocks_ts3; // : blocks_ts3
extern short  *blocks_ts4; // : blocks_ts4
extern short  *blocks_ts5; // : blocks_ts5
extern short  *blocks_ts6; // : blocks_ts6
extern short  *blocks_ts7; // : blocks_ts7
extern short  *blocks_ts8; // : blocks_ts8
extern BYTE   *blocks_connect_type; // : blocks_connect_type
extern BYTE   *blocks_state; // : blocks_state
extern double *blocks_gen; // : blocks_gen

// : shunts
extern DWORD shunts_max; //    
extern DWORD *p_shunts; //     
#define	shunts_cur	(*p_shunts) //   
extern int    *shunts_nod; // : shunts_nod
extern BYTE   *shunts_num; // : shunts_num
extern short  *shunts_ts1; // : shunts_ts1
extern short  *shunts_ts2; // : shunts_ts2
extern short  *shunts_ts3; // : shunts_ts3
extern short  *shunts_ts4; // : shunts_ts4
extern short  *shunts_ts5; // : shunts_ts5
extern short  *shunts_ts6; // : shunts_ts6
extern short  *shunts_ts7; // : shunts_ts7
extern short  *shunts_ts8; // : shunts_ts8
extern BYTE   *shunts_connect_type; // : shunts_connect_type
extern BYTE   *shunts_state; // : shunts_state

// : UKZ
extern DWORD UKZ_max; //    
extern DWORD *p_UKZ; //     
#define	UKZ_cur	(*p_UKZ) //   
extern short  *UNOB1; // : 
extern short  *UNOB2; // : _
extern short  *UNOB3; // : _
extern short  *UNOB4; // :   _1  
extern short  *UNOB5; // : _2
extern short  *UNOB6; // : _3
extern short  *UNOB7; // : _4
extern short  *UNOB8; // : _5
extern float  *UKZ0; // :  t_ 
extern float  *UKZ1; // :  t_
extern float  *UKZ4; // :  _
extern float  *UKZ5; // :  _

// : LKZ
extern DWORD LKZ_max; //    
extern DWORD *p_LKZ; //     
#define	LKZ_cur	(*p_LKZ) //   
extern short  *NOB1; // : 
extern short  *NOB2; // :  (%)
extern short  *NOB3; // : _
extern float  *TKZ0; // : _1- 
extern float  *TKZ1; // : _1- 
extern float  *TKZ2; // :  2- 
extern float  *TKZ3; // : _2- 
extern float  *TKZ4; // :  _
extern float  *TKZ5; // :  _
extern float  *TKZ6; // :  _
extern float  *TKZ7; // :  _

// : . . .
extern DWORD n_tek_max; //    
extern DWORD *p_n_tek; //     
#define	n_tek_cur	(*p_n_tek) //   
extern int    *NON; // :  
extern c30    *NAN; // :  
extern float  *DOL; // : _ 
extern float  *UN; // : 
extern float  *FAN; // : 
extern float  *FN; // : 
extern float  *BLC; // : __ _ 
extern float  *PNA; // : __ _ 
extern float  *BLR; // : __ _
extern float  *PNQ; // : __ _
extern short  *TUN; // : _ 
extern short  *KSN; // : - 
extern float  *SNAS; // :   
extern float  *SNRS; // :   
extern float  *SNA; // : _  
extern float  *SNR; // : _  
extern char   *QBL; // : _ 
extern short  *REN; // :  _ %
extern short  *DAD; // :   __ %
extern float  *PON; // :  _ 
extern short  *NRN; // :  
extern short  *NRN_TR; // :  
extern float  *NL_InjectionP; // :    _ P
extern float  *NL_InjectionQ; // :    _ P
extern char   *QSN; // : QSN
extern char   *QFRN; // : QFRN
extern short  *TDA; // : TDA
extern float  *SAD; // : SAD
extern float  *QAD; // : __QAD__
extern float  *RMAD; // : RMAD
extern float  *PAD; // : _  
extern float  *FAD; // : __FAD_
extern float  *UIZ; // : __UIZ_
extern int    *BKRN; // : BKRN
extern float  *NL_UPMax; // : U _ max
extern float  *NL_UPMin; // : U _ min
extern float  *NL_UAMax; // : U  max
extern float  *NL_UAMin; // : U  min
extern float  *EMAL; // :    
extern float  *MMAL; // :    
extern float  *SiAD; // :   

// : . . .
extern DWORD g_tek_max; //    
extern DWORD *p_g_tek; //     
#define	g_tek_cur	(*p_g_tek) //   
extern int    *NUG; // :  
extern c30    *NAG; // :  
extern float  *UU; // : 
extern float  *FAZA; // :  
extern float  *F; // : 
extern float  *SAL; // :   _
extern float  *AK; // : _
extern float  *AKI; // : _ _
extern float  *PAG; // : _
extern float  *BAG; // : _ _
extern float  *UGN; // :  U
extern float  *UMAX; // : MAX U
extern float  *UMIN; // : MIN U
extern float  *DUG; // : _ _ _
extern float  *FUG; // : FUG
extern float  *PQG; // : _
extern float  *QKS; // : _
extern short  *KSG; // : - 
extern float  *SGAS; // :   
extern float  *SGRS; // :   
extern float  *SGA; // : _ 
extern float  *SGR; // : _ 
extern float  *UUR; // : _ 
extern float  *UUS; // : _ _U
extern float  *UF; // : _ 
extern float  *UO; // : _ 
extern char   *QSG; // : _ 
extern short  *NTIG; // :  
extern short  *REG_REG; // :  
extern short  *REG_REG_TR; // :  
extern char   *QGN; // : _ 
extern float  *APBN; // : P  _
extern float  *APB; // : P  _
extern float  *NG_InjectionP; // :    _ P
extern float  *NG_InjectionQ; // :    _ P
extern char   *TUG; // : _TUG_
extern char   *QFRG; // : QFRG
extern float  *QMAX; // : _QMAX_
extern float  *QMIN; // : _QMIN_
extern short  *PMIN; // : _PMIN_
extern short  *PMAX; // : _PMAX_
extern short  *PAFR; // : _PAFR_
extern short  *KBL; // : _KBL_
extern short  *KBLN; // : _KBLN_
extern short  *TDD; // : _TDD_
extern short  *NDT; // : _NDT_
extern short  *NDG; // : _NDG_
extern int    *BKBG; // : BKBG
extern int    *BKBN; // : BKBN
extern int    *BKRG; // : BKRG
extern float  *PRICE; // : PRICE
extern float  *REA; // : _REA_
extern float  *UG1; // : _UG1_
extern float  *G0; // : __G0__
extern float  *G1; // : __G1__
extern float  *G2; // : __G2__
extern float  *G3; // : __G3__
extern float  *uff; // : ___uff___
extern float  *uqp; // : _uqp_
extern float  *uup; // : _uup_
extern float  *ft; // : __ft__
extern float  *fg; // : __fg__
extern float  *fa; // : __fa__
extern float  *ff; // : __ff__
extern float  *BQG; // : _BQG_
extern float  *PDD; // : _PDD_
extern short  *SV; // : _SV_
extern float  *UGP; // : __UGP__
extern float  *DUR; // : _DUR_
extern float  *AKF; // : _AKF_
extern float  *AKP; // : _AKP_
extern int    *X_NODE; // : X
extern int    *Y_NODE; // : Y
extern float  *NG_UPMax; // : U _ max
extern float  *NG_UPMin; // : U _ min
extern float  *NG_UAMax; // : U  max
extern float  *NG_UAMin; // : U  min
extern float  *NG_PPMax; // : P _ max
extern float  *NG_PPMin; // : P _ min
extern float  *NG_PAMax; // : P  max
extern float  *NG_PAMin; // : P  min
extern short  *SubId; // :  ()
extern float  *KoefCor; // :  
extern BYTE   *GDEAD; // : 
extern float  *Pbal; // :  P
extern float  *Qbal; // :  Q
extern BYTE   *typeLimQ; // :     
extern short  *AKM; // : AKM
extern short  *ADIN; // : ADIN
extern float  *AKTEK; // : AKTEK
extern float  *bnp; // : bnp
extern float  *bb; // : bb
extern BYTE   *g_IsTrans; // : 
extern float  *NFU; // :   
extern float  *UUC; // :   

// : modtime
extern DWORD modtime_max; //    
extern DWORD *p_modtime; //     
#define	modtime_cur	(*p_modtime) //   
extern double *timeM; // :  
extern short  *MaxdtCounter; // :    tick
extern float  *DT; // :  , 

// :  
extern DWORD All_nodes_max; //    
extern DWORD *p_All_nodes; //     
#define	All_nodes_cur	(*p_All_nodes) //   
extern int    *NGN; // :  
extern c30    *NAGN; // :  
extern float  *RND; // :  _ _
extern float  *SS; // :   _
extern float  *SAR; // :  
extern float  *SAQ; // :  
extern float  *EMU; // :   
extern float  *RMU; // : _  
extern float  *FANP; // :   _
extern float  *UUGN; // :     
extern float  *UGNA; // : _ _ 
extern float  *FFGN; // :  
extern short  *AllRegNodes; // :  
extern short  *FLAG_NODE; // : 
extern short  *X_sh; // :      
extern short  *Y_sh; // :   Y   
extern BYTE   *DEAD; // : 
extern float  *RND_UUGN; // : _U
extern float  *RND_FANP; // : _
extern BYTE   *GRN; // : 
extern short  *X_sh1; // : 
extern short  *Y_sh1; // : 

// :  
extern DWORD NameSch_max; //    
extern DWORD *p_NameSch; //     
#define	NameSch_cur	(*p_NameSch) //   
extern c50    *NAME; // :  
extern c128   *Comment; // : _
extern c128   *File_schm; // :  
extern int    *SupportNodeTech; // :  
extern short  *NU; // : - 
extern short  *MM; // : - 
extern short  *N1; // : - 

// : 
extern DWORD Upravl_max; //    
extern DWORD *p_Upravl; //     
#define	Upravl_cur	(*p_Upravl) //   
extern char   *SZ; // :  
extern int    *SZINT; // :  
extern float  *SZFLOAT; // :    

// : 
extern DWORD Upravl2_max; //    
extern DWORD *p_Upravl2; //     
#define	Upravl2_cur	(*p_Upravl2) //   
extern BYTE   *AfterLoadPause; // : 
extern int    *BaseNug; // : 
extern float  *FreqInBase; // : 

// : . . 
extern DWORD L_tek_max; //    
extern DWORD *p_L_tek; //     
#define	L_tek_cur	(*p_L_tek) //   
extern int    *Lnum; // :  
extern int    *KG_ind; // :  
extern int    *KL_ind; // :  
extern int    *KG_ish; // : 1- 
extern int    *KL_ish; // : 2- 
extern c12    *NAL; // :  
extern BYTE   *LType; // :  
extern short  *NLI; // :  
extern short  *NRL; // :  
extern float  *PER; // : _ _ 
extern float  *PER1; // : _ _ 
extern float  *PER2; // : _ _ 
extern float  *POT; // : _ 
extern float  *PEQ; // : _ _ 
extern float  *PEQ1; // : _ _ 
extern float  *PEQ2; // : _ _ 
extern float  *PQT; // : _ 
extern float  *TOK1; // :   1-  
extern float  *TOK_START; // :   1-  
extern float  *TOK_END; // :   2-  
extern float  *TRA; // :   _  
extern float  *TRK; // : _ 
extern float  *TRKM; // : _ 
extern char   *BKL; // :  
extern BYTE   *BKL1; // :  
extern BYTE   *BKL2; // :  
extern BYTE   *LCH1; // :    1- 
extern BYTE   *LCH2; // :    2- 
extern char   *QDA; // :  __
extern char   *QON; // :  
extern short  *OL; // :   
extern float  *SIR; // : _  
extern float  *SIG; // : _  
extern float  *EMK; // :  
extern float  *KORON; // :  
extern float  *NFL; // :    
extern float  *QFL; // :    
extern float  *NFQ; // :    
extern BYTE   *BFL; // :   
extern int    *NTIL; // :  
extern short  *PRL; // :  
extern short  *LnumD; // :  
extern float  *L_PPMax; // : P _ max
extern float  *L_PPMin; // : P _ min
extern float  *L_PAMax; // : P  max
extern float  *L_PAMin; // : P  min
extern float  *L_IPMax; // : I _ max
extern float  *L_IPMin; // : I _ min
extern float  *L_IAMax; // : I  max
extern float  *L_IAMin; // : I  min
extern float  *U_start; // : U 
extern float  *U_end; // : U 
extern c100   *NALF; // :   
extern BYTE   *INVAL; // :  
extern float  *RND_PER1; // : __
extern float  *RND_PER2; // : __
extern float  *RND_PEQ1; // : __
extern float  *RND_PEQ2; // : __
extern float  *RND_TOK1; // : _I1
extern float  *RND_FAZA_TOK1; // : _1
extern float  *RND_TOK2; // : _I2
extern float  *RND_FAZA_TOK2; // : _2
extern short  *L_SubId1; // : L_SubId1
extern short  *L_SubId2; // : L_SubId2
extern short  *NomAnc; // :  
extern BYTE   *LGRN1; // :  1
extern BYTE   *LGRN2; // :  2
extern BYTE   *LDEAD1; // :  
extern BYTE   *LDEAD2; // :  
extern float  *L_unom1; // : 
extern float  *L_unom2; // : 
extern BYTE   *L_istrans; // : 

// : L_ts
extern DWORD L_ts_max; //    
extern DWORD *p_L_ts; //     
#define	L_ts_cur	(*p_L_ts) //   
extern short  *L_ts_Begin1; // : L_ts_Begin1
extern short  *L_ts_Begin2; // : L_ts_Begin2
extern short  *L_ts_Begin3; // : L_ts_Begin3
extern short  *L_ts_Begin4; // :  4
extern short  *L_ts_Begin5; // :  5
extern short  *L_ts_Begin6; // :  6
extern short  *L_ts_Begin7; // :  7
extern short  *L_ts_Begin8; // :  8
extern short  *L_ts_End1; // : L_ts_End1
extern short  *L_ts_End2; // : L_ts_End2
extern short  *L_ts_End3; // : L_ts_End3
extern short  *L_ts_End4; // : 4
extern short  *L_ts_End5; // : 5
extern short  *L_ts_End6; // : 6
extern short  *L_ts_End7; // : 7
extern short  *L_ts_End8; // : 8
extern int    *L_ts_begin; // : 
extern int    *L_ts_end; // : 
extern short  *L_ts_paralel; // :  
extern BYTE   *L_ts_type_begin; // :   
extern BYTE   *L_ts_type_end; // :   

extern LPVOID commodBuf; //    
extern HANDLE commodMap; //    

//   sdf  
//  :
// 0 -  -     c-,     .
// 1 -   ,   
// 2 -  
extern int commodOpen(const char* name);

//   
extern void commodClose();

#ifdef __cplusplus
}
#endif

#pragma pack(pop)

#endif //_commod_h_19_07_2024
