sub RecalcFactor(startType, starMonth, startHours, curType, curMonth, curHours)
'	MsgBox "RecalcFactor"
	Dim hh
	Dim mm
	Dim factor1
	Dim factor2
	Dim factorM1
	Dim factorM2

'	MsgBox "%%"
	
	hh = Left(startHours, 2)
	mm = Right(startHours, 2)

	query = "Ted\Factor.tbl\DAY\" & startType & "\HOURS  =  " & CInt(hh) & " & MINUTE = " & CInt(mm) & "\\s"

	Set bind = CreateObject("Cascade.Bind")

	bind.Open(query )

	factor1 = bind(1,1)

	hh = Left(curHours, 2)
	mm = Right(curHours, 2)

	query = "Ted\Factor.tbl\DAY\" & curType & "\HOURS  =  " & CInt(hh) & " & MINUTE = " & CInt(mm) & "\\s"

	bind.Open(query )
	factor2 = bind(1,1)

	query = "Ted\Factor.tbl\MONTH\P\NUMBER=" & CInt(starMonth) & "\\s"
	bind.Open(query )
	factorM1 = bind(1,1)

	query = "Ted\Factor.tbl\MONTH\P\NUMBER=" & CInt(curMonth) & "\\s"
	bind.Open(query )
	factorM2 = bind(1,1)

	ctrFactorTimeGraph.RepValue = CStr(Round(factor2 / factor1 * factorM2 / factorM1, 4))
end sub

Function PadLeft(lngLong, lngLength, strPad)
	If Len(lngLong) < lngLength Then
		PadLeft = String(lngLength - Len(lngLong), strPad) & lngLong
	Else
		PadLeft = lngLong
	End If
End Function

Sub ChangeNodesValues(strFactor,strRid,strNid,strParamType,strLimit)
	If Not IsNumeric(strFactor)  Then
	  MsgBox "  "
	ElseIf Len(strRid) = 0 Then
	  MsgBox "  "
	ElseIf Len(strNid) = 0 Then
	  MsgBox "   "
	ElseIf strFactor <> "1" Then
		rid = strRid
		nid = strNid
		paramType = strParamType
		factor = strFactor
		limit = strLimit

		gfilter = ""
		nfilter = ""
		If nid <> 0 Then
			gfilter = "NUG=" & nid
			nfilter = "NON=" & nid
		End If
	  
		If rid <> 0 then
			if Len(gfilter) > 0 then
				gfilter = gfilter & "&" & "REG_REG=" & rid
				nfilter = nfilter & "&" & "NRN=" & rid
			else
				gfilter = "REG_REG=" & rid
				nfilter = "NRN=" & rid
			end if
		end if
	  
		Set bn = CreateObject("Cascade.Bind")
		Set bg = CreateObject("Cascade.Bind")
		
		bg.Open "commod.sdf\g_tek\UU, AKI * 1.2, AK\" & gfilter & "\\s"

		Dim workCount
		akSum = 0
		akWork = 0
		ak = 0
		Dim AkiArray()
		ReDim AkiArray(bg.RecCount + 1)

		For r = 1 To bg.RecCount
			ak = bg(3, r)
			If ak > 0 Then
				If bg(1, r) > 0.1 Then
					akWork = akWork + ak
				End If
				akSum = akSum + ak
			End If
			AkiArray(r) = bg(2, r)
		Next
		
		bg.Close

		if akWork > 0 then  
			gFactor = CDbl(akSum) / akWork
		else
			gFactor = 1
		end if

		gFieldNames = Array(, "BAG", "DUG", "AK")
		nFieldNames = Array(, "BLC", "BLR", "77")

		gfields = "" '    g_tek sdf-,   
		nfields = "" '    n_tek sdf-,   
		If paramType > 0 Then
			gfields = gFieldNames(paramType)
			nfields = nFieldNames(paramType)
		Else
			For i = 1 To UBound(gFieldNames)
				If i > 1 Then
					gfields = gfields + ","
					nfields = nfields + ","
				End If
				gfields = gfields + gFieldNames(i)
				nfields = nfields + nFieldNames(i)
			Next
		End If

		bg.Open "commod.sdf\g_tek\" & gfields & "\" & gfilter & "\\s"
		bn.Open "commod.sdf\n_tek\" & nfields & "\" & nfilter & "\\s"

		g = bg.CellData
		n = bn.CellData

		grecs = bg.RecCount
		nrecs = bn.RecCount
		cols = bg.ColCount

		pMax = 0
		pCur = 0
		pRests = 0
		Dim addArray()
		ReDim addArray(0)
		akSum = 0

		For r = 1 To grecs
			For c = 1 To cols
				ak = g(c,r) 
				If ak > 0 Then
					If c = 3 Then
						pMax = AkiArray(r)
						pCur = ak * factor * gFactor
						If limit = 1 Then
							If pCur < pMax Then
								g(c,r) = pCur
								addArray(UBound(addArray)) = r
								ReDim Preserve addArray(UBound(addArray) + 1)
								akSum = akSum + pCur
							ElseIf pMax <= pCur Then 
								g(c, r) = pMax
								pRests = pRests + pCur - pMax
							End If
						Else
							g(c, r) = pCur
						End If
					Else
						g(c,r) = g(c,r) * factor
					End If
				End If
			Next
		Next
		
		bg.CellData = g
		bg.WriteToDB

		Set bindRecalcMatrix = CreateObject("Cascade.Bind")
		bindRecalcMatrix.Open("commod.sdf\Upravl\SZ\THIS\1\c")
		bindRecalcMatrix(1,1) = 1
		bindRecalcMatrix.WriteToDB
'
		If limit = 1 Then
			ReDim Preserve addArray(UBound(addArray) - 1)
			Dim pDelta
			'MsgBox UBound(addArray) & " : " & akSum & " : " & pRests 
			Do While pRests > 0 And UBound(addArray) >= 0
				pDelta = pRests
				pRests = 0
				countAdd = 0
				akSumNew = 0
				For i = LBound(addArray) To UBound(addArray)
					pMax = AkiArray(addArray(i))
					pCur = g(3,addArray(i)) + g(3,addArray(i)) * pDelta / akSum
					'MsgBox pCur & " : " & pDelta & " : " & akSum
					If pCur < pMax Then
						g(3,addArray(i)) = pCur
						AddArray(countAdd ) = addArray(i)
						countAdd = countAdd + 1
						akSumNew = akSumNew + pCur
					ElseIf pMax <= pCur Then 
						g(3, addArray(i)) = pMax
						pRests = pRests + pCur - pMax
					End If
				Next
				ReDim Preserve addArray(countAdd - 1)
				akSum = akSumNew
			Loop
		End If

		bg.CellData = g
		bg.WriteToDB

		bindRecalcMatrix(1,1) = 1
		bindRecalcMatrix.WriteToDB

		If pRests = 0 Then
			MsgBox "  "
		Else
			MsgBox "   " & Round(pRests, 2) & " "
		End If

	End If
	
end sub
