/*****************************************************************/
/* h-   Tabula     */
/*  : z:\casfsk\cascade.sdf                               */
/*****************************************************************/

#ifndef __cascadesdf_h_11_10_2019
#define __cascadesdf_h_11_10_2019

#pragma pack(push, 1)

#ifdef __cplusplus
extern "C" {
#endif
#ifndef __TABULA_STRUCT__29_09_2006
#define __TABULA_STRUCT__29_09_2006

#include <windows.h>
#include <stdlib.h>
#include <malloc.h>
#include <string.h>

// -     sdf 

//  
struct sField{
	char	name[256];			// 
	WORD	type;				// 
	DWORD	off;				//      
	DWORD	offData;			// --//--  
};

//  
struct sTable{
	char	name[256];			// 
	DWORD	off;				//     -   
	DWORD	offData;			// --//-- -  	
	DWORD	nCountR;			//-  ()
	WORD	nCountF;			//- 
	DWORD	SizeOfFields;		//  
	DWORD	*p_CurRecord;		//  
	
	struct sField* infoField;	//   	
};

// -   
#define TYPESIZE(t) (t + (t == 3) + 3 * (t == 5) - 2 * (t == 6) - 8 * (t >= 8))

#endif //__TABULA_STRUCT__29_09_2006

//   
typedef char c50[50];
typedef char c100[100];
typedef char c2048[2048];

// : MmiVar
extern DWORD MmiVar_max; //    
extern DWORD *p_MmiVar; //     
#define	MmiVar_cur	(*p_MmiVar) //   
//    
typedef struct _struct_MmiVar
{
	c100   name; // : name
	c100   val; // : val
	c100   val0; // : val0
} struct_MmiVar;
extern struct_MmiVar *MmiVar;

// :    
extern DWORD ScnRec_max; //    
extern DWORD *p_ScnRec; //     
#define	ScnRec_cur	(*p_ScnRec) //   
//    
typedef struct _struct_ScnRec
{
	BYTE   on; // :   
	c50    name; // :  
	BYTE   times; // :  
	BYTE   boxes; // :  
	BYTE   comments; // :  
	BYTE   inIf; // :    
	BYTE   inWhile; // :    
	int    lastRecordTime; // :   
	int    freezeTime; // :  
} struct_ScnRec;
extern struct_ScnRec *ScnRec;

extern LPVOID cascadesdfBuf; //    
extern HANDLE cascadesdfMap; //    

//   sdf  
//  :
// 0 -  -     c-,     .
// 1 -   ,   
// 2 -  
extern int cascadesdfOpen(const char* name);

//   
extern void cascadesdfClose();

#ifdef __cplusplus
}
#endif

#pragma pack(pop)

#endif //_cascadesdf_h_11_10_2019
