/*****************************************************************/
/* h-   Tabula     */
/*  : z:\casfsk\oik.sdf                                   */
/*****************************************************************/

#ifndef __oiksdf_h_11_10_2019
#define __oiksdf_h_11_10_2019

#pragma pack(push, 1)

#ifdef __cplusplus
extern "C" {
#endif
#ifndef __TABULA_STRUCT__29_09_2006
#define __TABULA_STRUCT__29_09_2006

#include <windows.h>
#include <stdlib.h>
#include <malloc.h>
#include <string.h>

// -     sdf 

//  
struct sField{
	char	name[256];			// 
	WORD	type;				// 
	DWORD	off;				//      
	DWORD	offData;			// --//--  
};

//  
struct sTable{
	char	name[256];			// 
	DWORD	off;				//     -   
	DWORD	offData;			// --//-- -  	
	DWORD	nCountR;			//-  ()
	WORD	nCountF;			//- 
	DWORD	SizeOfFields;		//  
	DWORD	*p_CurRecord;		//  
	
	struct sField* infoField;	//   	
};

// -   
#define TYPESIZE(t) (t + (t == 3) + 3 * (t == 5) - 2 * (t == 6) - 8 * (t >= 8))

#endif //__TABULA_STRUCT__29_09_2006

//   
typedef char c64[64];
typedef char c2048[2048];

// : ti
extern DWORD ti_max; //    
extern DWORD *p_ti; //     
#define	ti_cur	(*p_ti) //   
extern int    *tiObj; // : tiObj
extern int    *tiId; // : tiId
extern c64    *tiName; // : tiName
extern double *tiVal; // : tiVal
extern int    *tiStatus; // : tiStatus
extern int    *tiTime; // : tiTime
extern BYTE   *tiType; // : tiType
extern int    *tiSrc; // : tiSrc

// : ts
extern DWORD ts_max; //    
extern DWORD *p_ts; //     
#define	ts_cur	(*p_ts) //   
extern int    *tsObj; // : tsObj
extern int    *tsId; // : tsId
extern c64    *tsName; // : tsName
extern BYTE   *tsVal; // : tsVal
extern int    *tsStatus; // : tsStatus
extern int    *tsTime; // : tsTime
extern int    *tsSrc; // : tsSrc

extern LPVOID oiksdfBuf; //    
extern HANDLE oiksdfMap; //    

//   sdf  
//  :
// 0 -  -     c-,     .
// 1 -   ,   
// 2 -  
extern int oiksdfOpen(const char* name);

//   
extern void oiksdfClose();

#ifdef __cplusplus
}
#endif

#pragma pack(pop)

#endif //_oiksdf_h_11_10_2019
