/*****************************************************************/
/* h-   Tabula     */
/*  : C:\cascade\regions.sdf                              */
/*****************************************************************/

#ifndef __regions_h_13_03_2013
#define __regions_h_13_03_2013

#pragma pack(push, 1)

#ifdef __cplusplus
extern "C" {
#endif
#ifndef __TABULA_STRUCT__29_09_2006
#define __TABULA_STRUCT__29_09_2006

#include <windows.h>
#include <stdlib.h>
#include <malloc.h>
#include <string.h>

// -     sdf 

//  
struct sField{
	char	name[256];			// 
	WORD	type;				// 
	DWORD	off;				//      
	DWORD	offData;			// --//--  
};

//  
struct sTable{
	char	name[256];			// 
	DWORD	off;				//     -   
	DWORD	offData;			// --//-- -  	
	DWORD	nCountR;			//-  ()
	WORD	nCountF;			//- 
	DWORD	SizeOfFields;		//  
	DWORD	*p_CurRecord;		//  
	
	struct sField* infoField;	//   	
};

// -   
#define TYPESIZE(t) (t + (t == 3) + 3 * (t == 5) - 2 * (t == 6) - 8 * (t >= 8))

#endif //__TABULA_STRUCT__29_09_2006

//   
typedef char c50[50];
typedef char c100[100];
typedef char c128[128];

// : SUMREGIONS
extern DWORD SUMREGIONS_max; //    
extern DWORD *p_SUMREGIONS; //     
#define	SUMREGIONS_cur	(*p_SUMREGIONS) //   
extern c100   *SUMNAMEPARAM; // : SUMNAMEPARAM
extern float  *SUMVALUES; // : SUMVALUES

// : 
extern DWORD temp_max; //    
extern DWORD *p_temp; //     
#define	temp_cur	(*p_temp) //   
extern short  *CurSection; // :  
extern short  *Temp2; // : Temp2

// :   
extern DWORD SECTION_max; //    
extern DWORD *p_SECTION; //     
#define	SECTION_cur	(*p_SECTION) //   
extern float  *LOS_R; // :      
extern float  *LOS_I; // :      
extern float  *LOS_R_C; // : p    
extern float  *LOS_I_C; // : p    
extern float  *Sech_Limits_Down_Act; // :   
extern float  *Sech_Limits_Down_Rea; // :   
extern float  *Sech_Limits_Up_Act; // :   
extern float  *Sech_Limits_Up_Rea; // :   
extern c128   *Sech_Name; // : Sech_Name

// :     
extern DWORD CONNECT_max; //    
extern DWORD *p_CONNECT; //     
#define	CONNECT_cur	(*p_CONNECT) //   
extern short  *INTER_ST; // :   
extern short  *INTER_END; // :   
extern float  *INTER_L_R; // :   
extern float  *INTER_L_I; // :   
extern float  *INTER_B_R; // :   
extern float  *INTER_B_I; // :   
extern float  *INTER_L_R_C; // :   
extern float  *INTER_L_I_C; // :   
extern float  *INTER_B_R_C; // :   
extern float  *INTER_B_I_C; // :   

// :    
extern DWORD REG_INF_max; //    
extern DWORD *p_REG_INF; //     
#define	REG_INF_cur	(*p_REG_INF) //   
extern c50    *REG_TAB_Name; // :  
extern float  *REG_TAB_SALDO_REAL; // :   
extern float  *REG_TAB_SALDO_IMAG; // :   
extern float  *REG_TAB_SALDO_REAL_INTEGR; // :    
extern float  *REG_TAB_SALDO_IMAG_INTEGR; // :    
extern float  *REG_TAB_LOSES_REAL; // :     p
extern float  *REG_TAB_LOSES_IMAG; // :     p
extern float  *REG_TAB_LOS_R_C; // :     
extern float  *REG_TAB_LOS_I_C; // :     
extern float  *REG_TAB_GEN_REAL_C; // :   
extern float  *REG_TAB_GEN_IMAG_C; // :   
extern float  *REG_TAB_GEN_REAL; // :   
extern float  *REG_TAB_GEN_IMAG; // :   
extern float  *REG_TAB_LD_REAL_C; // :   
extern float  *REG_TAB_LD_IMAG_C; // :   
extern float  *REG_TAB_LD_REAL; // :   
extern float  *REG_TAB_LD_IMAG; // :   
extern float  *REG_PLAN_LOAD_C; // :   
extern float  *REG_PLAN_GEN_REAL_C; // :    
extern float  *REG_PLAN_SALDO_REAL_C; // :   

// :       
extern DWORD MISS_LOAD_max; //    
extern DWORD *p_MISS_LOAD; //     
#define	MISS_LOAD_cur	(*p_MISS_LOAD) //   
extern float  *ML_R_C; // :     
extern float  *ML_I_C; // :     
extern float  *ML_R; // :    
extern float  *ML_I; // :    
extern float  *ML_N_R; // :    
extern float  *ML_N_I; // :    
extern float  *ML_DF; // :      
extern float  *ML_DF_C; // :       
extern float  *ML_DU; // :      
extern float  *ML_DU_C; // :       

// :     
extern DWORD MISS_LOAD_GEN_max; //    
extern DWORD *p_MISS_LOAD_GEN; //     
#define	MISS_LOAD_GEN_cur	(*p_MISS_LOAD_GEN) //   
extern float  *MGLG_MEN_C; // :    
extern float  *MGLG_MEN; // :    
extern float  *MGLG_COAST; // :    

extern LPVOID regionsBuf; //    
extern HANDLE regionsMap; //    

//   sdf  
//  :
// 0 -  -     c-,     .
// 1 -   ,   
// 2 -  
extern int regionsOpen(LPCTSTR name);

//   
extern void regionsClose();

#ifdef __cplusplus
}
#endif

#pragma pack(pop)

#endif //_regions_h_13_03_2013
