/*****************************************************************/
/* h-   Tabula     */
/*  : c:\casfsk\tren.sdf                                  */
/*****************************************************************/

#ifndef __tren_h_01_10_2024
#define __tren_h_01_10_2024

#pragma pack(push, 1)

#ifdef __cplusplus
extern "C" {
#endif
#ifndef __TABULA_STRUCT__29_09_2006
#define __TABULA_STRUCT__29_09_2006

#include <windows.h>
#include <stdlib.h>
#include <malloc.h>
#include <string.h>

// -     sdf 

//  
struct sField{
	char	name[256];			// 
	WORD	type;				// 
	DWORD	off;				//      
	DWORD	offData;			// --//--  
};

//  
struct sTable{
	char	name[256];			// 
	DWORD	off;				//     -   
	DWORD	offData;			// --//-- -  	
	DWORD	nCountR;			//-  ()
	WORD	nCountF;			//- 
	DWORD	SizeOfFields;		//  
	DWORD	*p_CurRecord;		//  
	
	struct sField* infoField;	//   	
};

// -   
#define TYPESIZE(t) (t + (t == 3) + 3 * (t == 5) - 2 * (t == 6) - 8 * (t >= 8))

#endif //__TABULA_STRUCT__29_09_2006

//   
typedef char c4[4];
typedef char c10[10];
typedef char c12[12];
typedef char c15[15];
typedef char c20[20];
typedef char c30[30];
typedef char c50[50];
typedef char c70[70];
typedef char c80[80];
typedef char c150[150];
typedef char c255[255];
typedef char c2048[2048];

// : 
extern DWORD arnt_max; //    
extern DWORD *p_arnt; //     
#define	arnt_cur	(*p_arnt) //   
extern int    *arnt_leading; // :  
extern c20    *arnt_followings; // : 

// : -  
extern DWORD DDopVoltLim_max; //    
extern DWORD *p_DDopVoltLim; //     
#define	DDopVoltLim_cur	(*p_DDopVoltLim) //   
extern c15    *ddvl_Unom; // :  
extern float  *ddvl_duration; // :   
extern float  *ddvl_coefficient; // :  
extern float  *ddvl_UnomMin; // : 
extern float  *ddvl_UnomMax; // : 

// :   
extern DWORD Umax_max; //    
extern DWORD *p_Umax; //     
#define	Umax_cur	(*p_Umax) //   
extern float  *umax_nom; // :  
extern float  *umax_max; // :  

// :   
extern DWORD gvo_max; //    
extern DWORD *p_gvo; //     
#define	gvo_cur	(*p_gvo) //   
extern short  *gvo_SubId; // : 
extern BYTE   *gvo_Sequen; // : 
extern int    *gvo_BrkId; // : 
extern c50    *gvo_SubName; // : 
extern c50    *gvo_LoadDesc; // : 
extern float  *gvo_LoadVal; // : 
extern short  *gvo_MaxTime; // : 
extern c10    *gvo_Who; // : 

// :  ...
extern DWORD aopo_max; //    
extern DWORD *p_aopo; //     
#define	aopo_cur	(*p_aopo) //   
extern int    *aopo_id; // :  
extern c50    *aopo_TokLines; // :  
extern c50    *aopo_TokDesc; // :    
extern float  *aopo_TokSummer; // :     
extern float  *aopo_TokWinter; // :     
extern c50    *aopo_LoadBreakers; // :  
extern c50    *aopo_LoadDesc; // :   
extern c50    *aopo_LineBreakers; // :  
extern BYTE   *aopo_work; // :  
extern BYTE   *aopo_out; // :  

// :  ..
extern DWORD aosn_max; //    
extern DWORD *p_aosn; //     
#define	aosn_cur	(*p_aosn) //   
extern int    *aosn_id; // :  
extern c50    *aosn_VoltBuses; // :   
extern c50    *aosn_VoltDesc; // :    
extern float  *aosn_VoltMin; // :    
extern c50    *aosn_OffBreakers; // :   
extern c50    *aosn_OffDesc; // :   
extern BYTE   *aosn_time; // :   
extern BYTE   *aosn_work; // :  
extern BYTE   *aosn_out; // :  

// : 
extern DWORD avr_max; //    
extern DWORD *p_avr; //     
#define	avr_cur	(*p_avr) //   
extern BYTE   *avr_id; // : 
extern c50    *avr_name; // : 
extern int    *avr_subid; // :  ()
extern float  *avr_volt0; // :  
extern int    *avr_ts0; // :  
extern int    *avr_ts1; // :  
extern int    *avr_ts2; // :  
extern c4     *avr_algo; // :  
extern BYTE   *avr_work; // :  
extern BYTE   *avr_out; // :  
extern int    *avr_bus1; // : avr_bus1
extern int    *avr_bus2; // : avr_bus2

// :  
extern DWORD TsLog_max; //    
extern DWORD *p_TsLog; //     
#define	TsLog_cur	(*p_TsLog) //   
extern int    *tslog_DevId; // :  
extern c50    *tslog_DevName; // :  
extern BYTE   *tslog_TsType; // : 
extern int    *tslog_SubId; // :  
extern c30    *tslog_SubDispName; // : 
extern BYTE   *tslog_NewState; // :  
extern int    *tslog_Tim; // : 

// :  
extern DWORD EndLines_max; //    
extern DWORD *p_EndLines; //     
#define	EndLines_cur	(*p_EndLines) //   
extern int    *eline_id; // : 
extern short  *eline_subid; // :  
extern c50    *eline_name; // : 
extern float  *eline_volt0; // :  
extern float  *eline_p; // :  
extern float  *eline_q; // :  
extern float  *eline_i; // : 
extern float  *eline_p0; // :   - 
extern float  *eline_q0; // :   - 
extern BYTE   *eline_on; // : 

// : ()
extern DWORD substn_max; //    
extern DWORD *p_substn; //     
#define	substn_cur	(*p_substn) //   
extern int    *sub_id; // : 
extern c50    *sub_name; // : 
extern c20    *sub_name1; // :   
extern c12    *sub_folder; // :   
extern c30    *sub_dispname; // : 
extern float  *sub_volt0; // :   
extern BYTE   *sub_isstation; // : 
extern float  *sub_volt; // :  
extern float  *sub_freq; // :    
extern float  *sub_sal1; // : -
extern float  *sub_p; // :  
extern float  *sub_q; // :  
extern float  *sub_frct; // :   
extern float  *sub_stk; // :   
extern BYTE   *sub_open; // : 
extern c255   *sub_file; // :    
extern c50    *sub_regim; // : ,    
extern BYTE   *sub_avr; // :  
extern BYTE   *sub_kvit; // : 
extern c15    *sub_pmes; // : 
extern BYTE   *sub_tu; // :  

// : 
extern DWORD station_max; //    
extern DWORD *p_station; //     
#define	station_cur	(*p_station) //   
extern int    *station_id; // : 
extern c50    *station_name; // : 
extern float  *station_pagsal; // : 
extern float  *station_ak; // : 
extern float  *station_pqg1; // : 
extern float  *station_pqg; // : 
extern float  *station_sal; // : 

// : Marks
extern DWORD Marks_max; //    
extern DWORD *p_Marks; //     
#define	Marks_cur	(*p_Marks) //   
extern int    *MrkId; // :  
extern int    *MrkTime; // : 
extern int    *MrkType; // :  
extern c30    *MrkName; // :   
extern c20    *MrkSymbol; // :   
extern short  *MrkIcon; // : 
extern int    *MrkX; // :  X
extern int    *MrkY; // :  Y
extern int    *MrkTypeEq; // :  
extern int    *MrkCodeEq; // :  
extern c70    *MrkEqName; // : 
extern c30    *MrkSubDispName; // : 
extern c255   *MrkComment; // : 
extern c150   *MrkAuthor; // :  

// : Zvk
extern DWORD Zvk_max; //    
extern DWORD *p_Zvk; //     
#define	Zvk_cur	(*p_Zvk) //   
extern int    *zvk_Id; // :  
extern BYTE   *zvk_Avar; // : 
extern BYTE   *zvk_State; // : 
extern int    *zvk_BegTime; // :  
extern int    *zvk_EndTime; // :  
extern int    *zvk_DevType; // :  
extern int    *zvk_DevId; // :  
extern c70    *zvk_DevName; // : 
extern int    *zvk_SubId; // :  
extern c30    *zvk_SubDispName; // : 

// : sms_zvk
extern DWORD sms_zvk_max; //    
extern DWORD *p_sms_zvk; //     
#define	sms_zvk_cur	(*p_sms_zvk) //   
extern BYTE   *ShowMode; // : ShowMode
extern BYTE   *StateTimeFilter; // : StateTimeFilter
extern int    *BegTimeFilter; // : BegTimeFilter
extern int    *EndTimeFilter; // : EndTimeFilter
extern c255   *DeviceFilter; // : DeviceFilter
extern c50    *StateFilter; // : StateFilter

// : zvkdevices
extern DWORD zvkdevices_max; //    
extern DWORD *p_zvkdevices; //     
#define	zvkdevices_cur	(*p_zvkdevices) //   
extern BYTE   *Type; // : Type
extern double *ModelId; // : ModelId

// : 
extern DWORD abr_max; //    
extern DWORD *p_abr; //     
#define	abr_cur	(*p_abr) //   
extern int    *abr_ts; // :  
extern c50    *abr_name; // : 
extern int    *abr_SubId; // :  ()
extern BYTE   *abr_type; // : 
extern float  *abr_volt0; // :  
extern BYTE   *abr_OperCur; // : _ 
extern BYTE   *abr_CanSync; // :  
extern BYTE   *abr_SyncState; // :  
extern BYTE   *abr_NeedCheck; // :   
extern float  *abr_per1; // : 
extern float  *abr_peq1; // : 
extern float  *abr_tok1; // : 
extern float  *abr_per2; // : 
extern float  *abr_peq2; // : 
extern float  *abr_tok2; // : 

// : 
extern DWORD tsn_max; //    
extern DWORD *p_tsn; //     
#define	tsn_cur	(*p_tsn) //   
extern int    *tsn_id; // : 
extern c50    *tsn_name; // : tsn_name
extern int    *tsn_SubId; // :  ()
extern float  *tsn_volt0; // :  
extern BYTE   *tsn_on; // : 
extern double *tsn_aload; // :  
extern double *tsn_rload; // :  
extern int    *tsn_moved; // :  

// : 1
extern DWORD trans1_max; //    
extern DWORD *p_trans1; //     
#define	trans1_cur	(*p_trans1) //   
extern int    *trans1_id; // : 
extern c50    *trans1_name; // :  
extern int    *trans1_SubId; // :  ()
extern float  *trans1_volt0; // :  
extern BYTE   *trans1_on; // : 
extern double *trans1_aload; // :  
extern double *trans1_rload; // :  

// : 2
extern DWORD trans2_max; //    
extern DWORD *p_trans2; //     
#define	trans2_cur	(*p_trans2) //   
extern int    *trans2_id; // : 
extern c30    *trans2_SubDispname; // : 
extern c50    *trans2_FullName; // :    
extern c10    *trans2_name; // :  
extern float  *trans2_Unom1; // :   1- 
extern float  *trans2_Unom2; // :   2- 
extern float  *trans2_Snom; // : 
extern int    *trans2_SubId; // :  ()
extern char   *trans2_bkl; // : 
extern float  *trans2_S; // : 
extern float  *trans2_per; // : 
extern float  *trans2_peq; // : 
extern float  *trans2_Inom1; // : 
extern float  *trans2_per1; // : 
extern float  *trans2_peq1; // : 
extern float  *trans2_S1; // : 
extern float  *trans2_Inom2; // : 
extern float  *trans2_per2; // : 
extern float  *trans2_peq2; // : 
extern float  *trans2_S2; // : 
extern float  *trans2_tok1; // : 
extern float  *trans2_tok2; // : 
extern int    *trans2_SubInd; // :  ()
extern BYTE   *trans2_RpnState; // :   
extern float  *trans2_DDopVn; // : I , 
extern float  *trans2_DDopNn; // : I , 
extern int    *trans2_DdopTimeVn; // :   I _ _  
extern int    *trans2_DdopTimeNn; // :   I _ _  
extern short  *trans2_DdopCountVn; // :   I _ _
extern short  *trans2_DdopCountNn; // :   I _ _
extern short  *trans2_arnt_p; // :   
extern short  *trans2_arnt_t; // :  
extern BYTE   *trans2_IsAdopVn; // :   
extern BYTE   *trans2_IsAdopNn; // :   
extern short  *trans2_AdopCountVn; // :    
extern short  *trans2_AdopCountNn; // :    
extern BYTE   *trans2_IsDdopVn; // :   
extern BYTE   *trans2_IsDdopNn; // :   

// : 3
extern DWORD trans3_max; //    
extern DWORD *p_trans3; //     
#define	trans3_cur	(*p_trans3) //   
extern int    *trans3_id; // : 
extern c30    *trans3_SubDispname; // : 
extern c50    *trans3_FullName; // :    
extern c10    *trans3_name; // :  
extern int    *trans3_SubId; // :  ()
extern float  *trans3_Unom1; // :   1- 
extern float  *trans3_Unom2; // :   2- 
extern float  *trans3_Unom3; // :   3- 
extern float  *trans3_Snom; // :  
extern float  *trans3_Inom1; // :   
extern float  *trans3_Inom2; // :   
extern int    *trans3_SubInd; // :  ()
extern float  *trans3_per1; // :     
extern float  *trans3_per2; // :     
extern float  *trans3_per3; // :     
extern float  *trans3_peq1; // :     
extern float  *trans3_peq2; // :     
extern float  *trans3_peq3; // :     
extern float  *trans3_tok1; // :    
extern float  *trans3_tok2; // :    
extern float  *trans3_tok3; // :    
extern float  *trans3_S1; // :  
extern BYTE   *trans3_RpnState; // :   
extern float  *trans3_DDopVn; // : I , 
extern float  *trans3_DDopSn; // : I C, 
extern float  *trans3_DDopNn; // : I , 
extern int    *trans3_DdopTimeVn; // :   I _ _  
extern int    *trans3_DdopTimeSn; // :   I _ _  
extern int    *trans3_DdopTimeNn; // :   I _ _  
extern short  *trans3_DdopCountVn; // :   I _ _
extern short  *trans3_DdopCountSn; // :   I _ _
extern short  *trans3_DdopCountNn; // :   I _ _
extern short  *trans3_arnt_p; // :   
extern short  *trans3_arnt_t; // :  
extern BYTE   *trans3_IsAdopVn; // :   
extern BYTE   *trans3_IsAdopSn; // :   
extern BYTE   *trans3_IsAdopNn; // :   
extern short  *trans3_AdopCountVn; // :    
extern short  *trans3_AdopCountSn; // :    
extern short  *trans3_AdopCountNn; // :    
extern BYTE   *trans3_IsDdopVn; // :   
extern BYTE   *trans3_IsDdopSn; // :   
extern BYTE   *trans3_IsDdopNn; // :   

// : 
extern DWORD fdr_max; //    
extern DWORD *p_fdr; //     
#define	fdr_cur	(*p_fdr) //   
extern int    *fdr_id; // : 
extern c50    *fdr_name; // : 
extern int    *fdr_SubId; // :  ()
extern float  *fdr_volt0; // :  
extern BYTE   *fdr_on; // : 
extern double *fdr_aload; // :  
extern double *fdr_rload; // :  

// :  
extern DWORD mbr_max; //    
extern DWORD *p_mbr; //     
#define	mbr_cur	(*p_mbr) //   
extern int    *mbr_ts; // :  
extern c50    *mbr_name; // : 
extern int    *mbr_SubId; // :  ()
extern BYTE   *mbr_type; // : 
extern float  *mbr_volt0; // :  
extern BYTE   *mbr_OperCur; // : _ 
extern BYTE   *mbr_slot2; // :  
extern float  *mbr_per1; // : 
extern float  *mbr_peq1; // : 
extern float  *mbr_per2; // : 
extern float  *mbr_peq2; // : 

// : 
extern DWORD bus_max; //    
extern DWORD *p_bus; //     
#define	bus_cur	(*p_bus) //   
extern int    *bus_id; // : 
extern int    *bus_subid; // :  
extern int    *bus_subind; // :   
extern BYTE   *bus_type; // : 
extern c30    *bus_SubDispname; // : 
extern c15    *bus_name; // : 
extern float  *bus_volt0; // :  
extern float  *bus_umin; // : 
extern float  *bus_umax; // : 
extern int    *bus_mdlind; // :  
extern int    *bus_mdlid; // :  
extern float  *bus_volt; // : 
extern float  *bus_freq; // : 
extern float  *bus_p; // :   
extern float  *bus_q; // :   
extern float  *bus_g; // :  
extern float  *bus_aki; // :  
extern float  *bus_qmax; // : 
extern float  *bus_qmin; // : 
extern float  *bus_ust_u; // :  
extern BYTE   *bus_Fixation; // :  
extern BYTE   *bus_dead; // :  
extern int    *bus_DdopTime; // :   _ _U  
extern BYTE   *bus_IsDdop; // :  _ _U
extern short  *bus_DdopCount; // :   _ _U

// :  
extern DWORD fbus_max; //    
extern DWORD *p_fbus; //     
#define	fbus_cur	(*p_fbus) //   
extern int    *fbus_id; // : 
extern short  *fbus_subid; // :  
extern int    *fbus_subind; // :   
extern c15    *fbus_name; // : 
extern float  *fbus_volt0; // :  
extern int    *fbus_mdlind; // :  /
extern int    *fbus_mdlid; // :  /
extern BYTE   *fbus_mdlType; // :   
extern float  *fbus_volt; // : 

// : 
extern DWORD line_max; //    
extern DWORD *p_line; //     
#define	line_cur	(*p_line) //   
extern int    *line_id; // : 
extern c70    *line_name; // : 
extern float  *line_volt0; // :  
extern float  *line_per; // : 
extern float  *line_peq; // : 
extern float  *line_tok; // : 
extern float  *line_per1; // : 
extern float  *line_peq1; // : 
extern float  *line_tok1; // : 
extern float  *line_per2; // : 
extern float  *line_peq2; // : 
extern float  *line_tok2; // : 
extern char   *line_bkl; // : 
extern BYTE   *line_kvit; // : 
extern BYTE   *line_inval; // : 
extern short  *line_SubId1; // :     
extern short  *line_SubId2; // :     
extern BYTE   *line_dead; // :   ( )
extern short  *line_Ddop; // :     
extern short  *line_Adop; // :     
extern float  *line_u1; // : 
extern float  *line_u2; // : 
extern BYTE   *line_AopoTime; // :  
extern float  *line_aopoTok; // :     
extern int    *line_DdopTime; // :   I _ _  
extern BYTE   *line_IsDdop; // :  I _ _
extern short  *line_DdopCount; // :   I _ _
extern BYTE   *line_IsAdop; // :   
extern short  *line_AdopCount; // :    

// :  
extern DWORD LineLim_max; //    
extern DWORD *p_LineLim; //     
#define	LineLim_cur	(*p_LineLim) //   
extern int    *liml_Lnum; // : 
extern c70    *liml_Name; // : 
extern short  *liml_Unom; // : 
extern c80    *liml_DdopTOE; // :  
extern c80    *liml_AdopTOE; // :  
extern float  *liml_I; // :  
extern short  *liml_Ddop; // : 
extern short  *liml_Adop; // : 
extern short  *liml_DdopM20; // :     -20 _
extern short  *liml_AdopM20; // :     -20 _
extern short  *liml_DdopM15; // : 
extern short  *liml_AdopM15; // : 
extern short  *liml_DdopM10; // : 
extern short  *liml_AdopM10; // : 
extern short  *liml_DdopM5; // : 
extern short  *liml_AdopM5; // : 
extern short  *liml_Ddop0; // : 
extern short  *liml_Adop0; // : 
extern short  *liml_Ddop5; // : 
extern short  *liml_Adop5; // : 
extern short  *liml_Ddop10; // : 
extern short  *liml_Adop10; // : 
extern short  *liml_Ddop15; // : 
extern short  *liml_Adop15; // : 
extern short  *liml_Ddop20; // : 
extern short  *liml_Adop20; // : 
extern short  *liml_Ddop25; // : 
extern short  *liml_Adop25; // : 
extern short  *liml_Ddop30; // : 
extern short  *liml_Adop30; // : 
extern short  *liml_Ddop35; // : 
extern short  *liml_Adop35; // : 
extern short  *liml_Ddop40; // : 
extern short  *liml_Adop40; // : 

// :   
extern DWORD VoltLim_max; //    
extern DWORD *p_VoltLim; //     
#define	VoltLim_cur	(*p_VoltLim) //   
extern int    *limv_SubId; // : 
extern int    *limv_SubInd; // : 
extern c30    *limv_SubDispname; // : 
extern float  *limv_Unom; // : 
extern float  *limv_Umin; // : 
extern float  *limv_Umax; // : 
extern c50    *limv_ExcepBuses; // : 

// :     
extern DWORD VoltLimBus_max; //    
extern DWORD *p_VoltLimBus; //     
#define	VoltLimBus_cur	(*p_VoltLimBus) //   
extern int    *limvb_BusId; // : 
extern c15    *limvb_BusName; // :  
extern c30    *limvb_SubDispname; // : 
extern float  *limvb_Unom; // : 
extern float  *limvb_Umin; // : 
extern float  *limvb_Umax; // : 
extern float  *limvb_U; // : 
extern BYTE   *limvb_Out; // : 

// : 
extern DWORD tn_max; //    
extern DWORD *p_tn; //     
#define	tn_cur	(*p_tn) //   
extern int    *tn_id; // : 
extern c50    *tn_name; // : 
extern int    *tn_SubId; // :  ()
extern float  *tn_volt0; // :  
extern BYTE   *tn_res; // :  
extern BYTE   *tn_nn; // :  
extern float  *tn_Ua; // :   A
extern float  *tn_Ub; // :   B
extern float  *tn_Uc; // :   C
extern float  *tn_Uab; // :   Uab
extern float  *tn_Ubc; // :   Ub
extern float  *tn_Uca; // :   Uca

// : options
extern DWORD options_max; //    
extern DWORD *p_options; //     
#define	options_cur	(*p_options) //   
extern BYTE   *archm; // : archm
extern BYTE   *Top; // : Top
extern BYTE   *IsolGrn; // : IsolGrn
extern BYTE   *AvrOn; // : AvrOn
extern BYTE   *LoadMode; // : LoadMode
extern int    *LoadTime; // : LoadTime
extern int    *ViewTime; // : ViewTime
extern BYTE   *schema; // : schema
extern c70    *LoadFile; // : LoadFile
extern BYTE   *ShowModel; // : ShowModel
extern BYTE   *ShowOik; // : ShowOik
extern BYTE   *LineViewMode; // : LineViewMode
extern BYTE   *CurTemp; // :  
extern BYTE   *WinterNow; // :  
extern BYTE   *NeedSaveSlice; // : 
extern short  *IdDopMaxTime; // :   I       
extern short  *IdDopTransMaxTime; // :   I         
extern BYTE   *IdDopTransPercent; // :   I     

// : zayavka
extern DWORD zayavka_max; //    
extern DWORD *p_zayavka; //     
#define	zayavka_cur	(*p_zayavka) //   
extern BYTE   *Mode; // : Mode
extern BYTE   *TimeMode; // : TimeMode
extern int    *Beg; // : Beg
extern int    *End; // : End
extern int    *DevMask; // : DevMask
extern int    *StateMask; // : StateMask

// : 
extern DWORD gen_max; //    
extern DWORD *p_gen; //     
#define	gen_cur	(*p_gen) //   
extern int    *gen_id; // : 
extern short  *gen_subid; // :  
extern c50    *gen_name; // : 
extern float  *gen_volt0; // :  
extern float  *gen_val; // : 
extern float  *gen_aki; // :  
extern float  *gen_rgen; // :  
extern float  *gen_qmin; // : 
extern float  *gen_qmax; // : 
extern float  *gen_pagsal; // : 
extern float  *gen_sal; // : 
extern float  *gen_ust_u; // :  
extern float  *gen_aload; // :   
extern float  *gen_rload; // :   
extern BYTE   *gen_on; // : 
extern int    *gen_mdlind; // :  
extern int    *gen_mdlid; // :  

// : 
extern DWORD hbr_max; //    
extern DWORD *p_hbr; //     
#define	hbr_cur	(*p_hbr) //   
extern int    *hbr_ts; // :  
extern c50    *hbr_name; // : 
extern int    *hbr_SubId; // :  ()
extern float  *hbr_volt0; // :  
extern BYTE   *hbr_EmKey; // : -
extern BYTE   *hbr_AbrBlock; // :  ( )
extern BYTE   *hbr_CheckState; // :  
extern BYTE   *hbr_PowerDrive; // :  

// : 
extern DWORD grn_max; //    
extern DWORD *p_grn; //     
#define	grn_cur	(*p_grn) //   
extern int    *grn_ts; // :  
extern c50    *grn_name; // : 
extern int    *grn_SubId; // :  ()
extern float  *grn_volt0; // :  
extern BYTE   *grn_CheckVolt; // :   
extern BYTE   *grn_short; // : 

// : 
extern DWORD rct_max; //    
extern DWORD *p_rct; //     
#define	rct_cur	(*p_rct) //   
extern int    *rct_id; // : 
extern c50    *rct_name; // : 
extern int    *rct_SubId; // :  ()
extern float  *rct_volt0; // :  
extern float  *rct_p; // :  
extern float  *rct_q; // :  
extern BYTE   *rct_on; // : 

// :   ()
extern DWORD frct_max; //    
extern DWORD *p_frct; //     
#define	frct_cur	(*p_frct) //   
extern int    *frct_id; // : 
extern c50    *frct_name; // : 
extern int    *frct_SubId; // :  ()
extern float  *frct_volt0; // :  
extern float  *frct_q; // :   
extern float  *frct_qmin; // : 
extern float  *frct_qmax; // : 
extern float  *frct_ust_u; // :  
extern BYTE   *frct_on; // : 
extern int    *frct_mdlind; // :  
extern int    *frct_mdlid; // :  

// : 
extern DWORD stk_max; //    
extern DWORD *p_stk; //     
#define	stk_cur	(*p_stk) //   
extern int    *stk_id; // : 
extern c50    *stk_name; // : 
extern int    *stk_SubId; // :  ()
extern float  *stk_volt0; // :  
extern float  *stk_qg; // :   
extern float  *stk_qmin; // : 
extern float  *stk_qmax; // : 
extern float  *stk_ust_q; // :  Q
extern float  *stk_ust_u; // :  
extern BYTE   *stk_on; // : 
extern int    *stk_mdlind; // :  
extern int    *stk_mdlid; // :  

// :  
extern DWORD users_max; //    
extern DWORD *p_users; //     
#define	users_cur	(*p_users) //   
extern c50    *usr_name; // :  
extern c50    *usr_comp; // :  
extern BYTE   *usr_type; // :  

// : 
extern DWORD toptask_max; //    
extern DWORD *p_toptask; //     
#define	toptask_cur	(*p_toptask) //   
extern int    *top_SubId; // :  ()
extern c10    *top_Action; // : 
extern c10    *top_TypeDevice; // :  
extern int    *top_Device; // : 

// : 
extern DWORD toplog_max; //    
extern DWORD *p_toplog; //     
#define	toplog_cur	(*p_toplog) //   
extern int    *toplog_number; // : 
extern BYTE   *toplog_oldstate; // : 
extern BYTE   *toplog_newstate; // : 
extern c50    *toplog_action; // : 
extern c50    *toplog_object; // : 
extern c50    *toplog_objname; // : 
extern c255   *toplog_message; // : 
extern short  *toplog_rating; // : 

extern LPVOID trenBuf; //    
extern HANDLE trenMap; //    

//   sdf  
//  :
// 0 -  -     c-,     .
// 1 -   ,   
// 2 -  
extern int trenOpen(const char* name);

//   
extern void trenClose();

#ifdef __cplusplus
}
#endif

#pragma pack(pop)

#endif //_tren_h_01_10_2024
